const fieldPropertiesPanel = '[data-test-id="properties-panel"]';
const backgroundColorSubmenu = `${fieldPropertiesPanel} [data-test-id="properties-menu"] [data-category="data-bgcolor"]`;
const backgroundColorPalette = `${fieldPropertiesPanel} .bgcolor.settings-colorswatch-colors`;
const enableColorButton = `${fieldPropertiesPanel} a[data-action="shelf-data-bgcolor"`;
const colorSettingPopOver = '.column-color-popover';
const fixedDimensionMapSetting = '[data-setting-id="dim_to_color_mapping"]';
const fixedDimensionToColorMapList = 'table.dim-color-mapping';
const fixedDimensionColorMapItem = `${fixedDimensionToColorMapList} .single-color`;
const colorpaletteSetting = '[data-test-id="colorpalettes-setting"]';
const activeColorPaletteColorItems =
  "[data_setting_id='color_palette'] .settings-palette.settings-color-selected .settings-swatch";
const addRangeColorIntervalButton = 'a.add-more-btn';
const measureRangeColorSetting = '[data-setting-id="measure_ranges"]';
const rangeSettingColorPalettePicker = '.color-mapper-palette-container';
const measureRangeColorSelectorButton = `${measureRangeColorSetting}  .measure-value-list:last .measure-value:last .single-color`;

const colorpaletteSelectionNthItem = (index: number) =>
  `${colorpaletteSetting} .settings-palette:nth-child(${index})`;
export const customColors = {
  fieldPropertiesPanel: {
    panel: fieldPropertiesPanel,
    backgroundColorSubmenu,
    backgroundColorPalette,
    enableColorButton,
    colorSettingPopOver: {
      panel: colorSettingPopOver,
    },
  },

  stylePanel: {
    colorSettingSection: {
      fixedDimensionToColorMapList,
      colorpaletteSelectionNthItem,
      activeColorPaletteColorItems,
      fixedDimensionColorMapItem,
      addRangeColorIntervalButton,
      measureRangeColorSetting,
      measureRangeColorSelectorButton,
      fixedDimensionMapSetting,
      rangeSettingColorPalettePicker,
    },
  },
};
