export const jobs = {
  job_type: '[aria-label="Type"]',
  job_interval: '[aria-label="Interval"]',
  job_name: '[aria-label="Name"]',
  job_threshold: '[aria-label="Threshold"]',
  job_schedule: '[aria-label="Schedule"]',
  job_schedule_status: '[aria-label="Schedule Status"]',
  job_owner: '[aria-label="Owner"]',
  email_subject: '[aria-label="Subject"]',
  email_message: '[aria-label="Message"]',
  email_attachments: '[aria-label="Attachments"]',
  email_limit: '[aria-label="Email Limit"',
  trigger_visual_id: '[aria-label="Trigger Visual ID"]',
  trigger_type: '[aria-label="Trigger Type"',
  trigger_condition: '[aria-label="Trigger Condition"]',
  email_template: '[data-test-id="emailTemplateLink"]',
  details_toggle: '[data-test-id="detailsToggle"]',
  previous_runs_table: '[data-test-id="previousRunsTable"]',
  cancel_run: '[aria-label="Cancel Run"]',
  run_details: '[aria-label="View Run Details"]',
  close_run_details: '[data-test-id="closeRunDetails"]',
  select_job_log: '[aria-label="Select Log"]',
  delete_job_logs: '[data-test-id="deleteJobLogs"]',
  job_actions: '[data-test-id="jobActions"]',
  job_actions_delete: '[data-test-id="jobActionsDelete"]',
  job_actions_run: '[data-test-id="jobActionsRun"]',
  job_actions_edit: '[data-test-id="jobActionsEdit"]',
  job_actions_change_owner: '[data-test-id="jobActionsChangeOwner"]',
  job_actions_pause_resume: '[data-test-id="jobActionsPauseResume"]',
  job_log_trigger_mode: '[data-test-id="triggerMode"]',
  change_job_owner_modal: '[data-test-id="changeJobOwnerModal"]',
  change_job_owner_current_owner: '[data-test-id="currentOwner"]',
  change_job_owner_select: '#changeJobOwner',
  change_job_owner_options: 'div[role="option"]',
  change_job_owner_save: '[data-test-id="saveChangeJobOwner"]',
  change_job_owner_cancel: '[data-test-id="cancelChangeJobOwner"]',
  go_back_to_jobs_button: '[data-test-id="goBackToJobs"]',
  job_details_modal: '[data-test-id="jobDetailsModal"]',
  email_modal: {
    form: '#emailModalForm',
    email_now: '#isScheduledFalse',
    email_scheduled : '#isScheduledTrue',
    is_threshold: '#isThreshold',
    email_tab: {
      trigger: '[data-rb-event-key="email"]',
      emailTo: '#emailTo',
      emailCc: '#emailCc',
      template: '#emailTemplateId',
      attachCsv: '#attachCsv',
      csvLimit: '[aria-label="Download row limit"]',
    },
    schedule_tab: {
      trigger: '[data-rb-event-key="schedule"]',
      schedule_group_id: '#scheduleGroupId',
      name: '[data-test-id="jobName"]',
      subject: '[data-test-id="emailSubject"]',
      message: '[data-test-id="emailMessage"]',
    },
    threshold_tab: {
      trigger: '[data-rb-event-key="threshold"]',
      create_visual: '[data-test-id="createTriggerVisual"]',
      trigger_id: '#triggerId',
      minimum_time_interval: '#editMinimumTimeInterval',
    },
    submit: '[data-test-id="submitEmailModalForm"]',
  },
  extract: {
    extract_owner: '[aria-label="Extract Owner"]',
    src_dataset: '[aria-label="Source Dataset"]',
    tgt_connection: '[aria-label="Target Data Connection"]',
    tgt_table: '[aria-label="Target Table"]',
  },
  status: {
    logs_tab: '[data-test-id="job_log_tab"]',
    schedules_tab: '[data-test-id="schedules_tab"]',
    schedule_groups_tab: '[data-test-id="schedule_group_tab"]',
    resume_selected: '[data-test-id="arc-resume-button"]',
    rerun_selected: '[data-test-id="arc-rerun-button"]',
    delete_selected: '[data-test-id="arc-delete-button"]',
    rerun: '[data-test-id="job-rerun"]',
    delete_checkbox: '[data-test-id="job-delete"]',
    delete_modal_yes: '[data-test-id="delete-yes"]',
  },
  job_overview: {
    refresh: '[data-test-id="refreshJobs"]',
    runs_table: '[data-test-id="runsTable"]',
    jobs_table: '[data-test-id="scheduledJobsTable"]',
    intervals_table: '[data-test-id="scheduleGroupsTable"]',
    runs_tab: '#runsTab',
    jobs_tab: '#scheduledJobsTab',
    intervals_tab: '#intervalsTab',
    job_name: '[data-test-id="jobName"]',
    job_owner: '[data-test-id="jobOwner"]',
    bulk_run_scheduled_jobs: '[data-test-id="bulkRun"]',
    bulk_delete_runs: '[data-test-id="deleteSelectedRuns"]',
    jobs: {
      select_job: '[aria-label="Select Job"]',
      actions: '[data-test-id="jobRowActions"]',
      run_now: '[data-test-id="runNow"]',
      edit: '[data-test-id="edit"]',
      details: '[data-test-id="details"]',
    },
    runs: {
      select_log: '[aria-label="Select Log"]',
      actions: '[data-test-id="runRowActions"]',
      run_now: '[data-test-id="runNow"]',
      delete: '[data-test-id="deleteRun"]',
    }
  },
  bulk_actions: {
    delete: '[data-test-id="deleteConfirm"]',
    run: '[data-test-id="runConfirm"]'
  }
};
