export const TEST_CONNECTIONS = {
  test_mysql_57: {
    connection_type: 'MySQL',
    connection_name: 'test_mysql_57',
    hostname: 'viz-team-6.cc-os.cloudera.com',
    port: '3308',
    username: 'root',
    password: 'cloudera',
  },
  test_mysql_8023: {
    connection_type: 'MySQL',
    connection_name: 'test_mysql_8023',
    hostname: 'viz-team-6.cc-os.cloudera.com',
    port: '3311',
    username: 'root',
    password: 'cloudera',
  },
  test_maria_10: {
    connection_type: 'MySQL',
    connection_name: 'test_maria_10',
    hostname: 'viz-team-6.cc-os.cloudera.com',
    port: '3310',
    username: 'root',
    password: 'cloudera',
  },
  test_postgres: {
    connection_type: 'PostgreSQL',
    connection_name: 'test_postgresql',
    hostname: 'viz-team-6.cc-os.cloudera.com',
    port: '5432',
    username: 'viz',
    password: 'cloudera',
    database: 'viz_test_db',
    advanced: {
      sock_type: 'normal_sock_type',
    },
  },
  test_impala: {
    connection_type: 'Impala',
    connection_name: 'test_impala',
    hostname: 'szhou-datavizimpala-3.vpc.cloudera.com',
    port: '21050',
    username: '',
    password: '',
    advanced: {
      conn_mode: 'binary_con_mode',
      sock_type: 'normal_sock_type',
      con_authtype: 'con_authtype_radio_nosasl',
    },
  },
  test_impala_knox: {
    connection_type: 'Impala',
    connection_name: 'test_impala_knox',
    hostname: 'viz-team-1.cc-os.cloudera.com',
    port: '8443',
    username: 'knoxui',
    password: 'knoxui',
    advanced: {
      conn_mode: 'http_con_mode',
      sock_type: 'ssl_sock_type_w_certificate',
      con_sslcert_name_mismatch: true,
      con_authtype: 'con_authtype_radio_ldap',
      con_hs2_http_sqlpath: 'gateway/cdp-proxy-api/impala',
    },
  },
  test_impala_kerberos_binary: {
    connection_type: 'Impala',
    connection_name: 'test_impala_kerberos_binary',
    hostname: 'viz-team-1.cc-os.cloudera.com',
    port: '21050',
    username: '',
    password: '',
    advanced: {
      conn_mode: 'binary_con_mode',
      sock_type: 'ssl_sock_type',
      con_authtype: 'con_authtype_radio_kerberos',
    },
  },
  test_impala_kerberos_http: {
    connection_type: 'Impala',
    connection_name: 'test_impala_kerberos_http',
    hostname: 'viz-team-1.cc-os.cloudera.com',
    port: '28000',
    username: '',
    password: '',
    advanced: {
      conn_mode: 'http_con_mode',
      sock_type: 'ssl_sock_type',
      con_authtype: 'con_authtype_radio_kerberos',
      con_hs2_http_sqlpath: 'cliservice',
    },
  },
  test_solr_kerberos_http: {
    connection_type: 'Solr (Tech Preview)',
    connection_name: 'test_solr_kerberos_http',
    hostname: 'viz-team-1.cc-os.cloudera.com',
    port: '8995',
    username: '',
    password: '',
    advanced: {
      sock_type: 'ssl_sock_type_w_certificate',
      con_sslcert_name_mismatch: true,
      con_authtype: 'con_authtype_radio_kerberos',
    },
  },
  test_solr_standalone: {
    connection_type: 'Solr (Tech Preview)',
    connection_name: 'test_solr_standalone',
    hostname: 'viz-team-6.cc-os.cloudera.com',
    port: '8983',
    solr_type: 'solr_type_standalone',
    advanced: {
      sock_type: 'normal_sock_type',
    },
  },
  test_solr_knox: {
    connection_type: 'Solr (Tech Preview)',
    connection_name: 'test_solr_knox',
    hostname: 'viz-team-1.cc-os.cloudera.com:8443/gateway/cdp-proxy-api/solr/',
    port: '8443',
    username: 'knoxui',
    password: 'knoxui',
    advanced: {
      sock_type: 'ssl_sock_type_w_certificate',
      con_sslcert_name_mismatch: true,
      con_authtype: 'con_authtype_radio_nosasl',
    },
  },
  test_hive: {
    connection_type: 'Hive',
    connection_name: 'test_hive',
    hostname: 'szhou-datavizimpala-1.vpc.cloudera.com',
    port: '10000',
    username: 'admin',
    password: '',
    advanced: {
      conn_mode: 'binary_con_mode',
      sock_type: 'normal_sock_type',
      con_authtype: 'con_authtype_radio_plain',
    },
  },
  test_hive_knox: {
    connection_type: 'Hive',
    connection_name: 'test_hive_knox',
    hostname: 'viz-team-1.cc-os.cloudera.com',
    port: '8443',
    username: 'knoxui',
    password: 'knoxui',
    advanced: {
      conn_mode: 'http_con_mode',
      sock_type: 'ssl_sock_type_w_certificate',
      con_sslcert_name_mismatch: true,
      con_authtype: 'con_authtype_radio_ldap',
      con_hs2_http_sqlpath: 'gateway/cdp-proxy-api/hive',
      application_name: '',
    },
  },
  test_hive_kerberos_binary: {
    connection_type: 'Hive',
    connection_name: 'test_hive_kerberos_binary',
    hostname: 'viz-team-1.cc-os.cloudera.com',
    port: '10000',
    username: '',
    password: '',
    advanced: {
      conn_mode: 'binary_con_mode',
      sock_type: 'ssl_sock_type',
      con_authtype: 'con_authtype_radio_kerberos',
    },
  },
  test_hive_kerberos_http: {
    connection_type: 'Hive',
    connection_name: 'test_hive_kerberos_http',
    hostname: 'viz-team-1.cc-os.cloudera.com',
    port: '10001',
    username: '',
    password: '',
    advanced: {
      conn_mode: 'http_con_mode',
      sock_type: 'ssl_sock_type',
      con_authtype: 'con_authtype_radio_kerberos',
      con_hs2_http_sqlpath: 'cliservice',
    },
  },
  test_sqlite: {
    connection_type: 'SQLite',
    connection_name: 'test_sqlite',
    filename: '/tmp/test.sqlite',
  },
  test_duckdb: {
    connection_type: 'DuckDB',
    connection_name: 'test_duckdb',
    filename: '/tmp/test.duckdb',
  },
};
