// Custom Colors Related Locators

export let locators = {
  custom_colors: 'a[href*="/apps/customcolors"]',
  custom_colors_tbl: 'table#table-customcolors',
  custom_clr_tbl_row: 'table#table-customcolors td:nth-child(2)',
  custom_clr_textbox:
    'div[class="sp-container sp-light sp-alpha-enabled sp-palette-buttons-disabled sp-initial-disabled"] input.sp-input',
  custom_clr_ok_btn:
    'div[class="sp-container sp-light sp-alpha-enabled sp-palette-buttons-disabled sp-initial-disabled"] button[class="sp-choose"]',
  addmore_btn: '.add-more-btn',
  color_pick_caret: 'div.custom-colors-wrapper  div.sp-dd',
  grouped_bars_vs: '#chart-trellis-groupedbars',
  color_palette: 'div.colorpalettes-setting',
  groupedbars: 'div[class^="arc-viz-container"][class$="arc-viz-type-trellis-groupedbars"]',
  new_custom_clr: '.new-customstyle',
  custom_color_row: '[data-test-id="custom-color-option"][data-test-item="color-name-placeholder"]',
  Delete_conf_modal: '#delete-confirmation-modal .modal-body input',
  Delete_btn: '#delete-confirmation-modal .modal-footer button#delete-confirmation-yes',
  clr_tbl_body: 'table#table-customcolors tbody',
  custom_dates: 'a[href*="/apps/customdates"]',
  add_range_btn: 'a#add-range-btn',
  range_names: 'div.custom-daterange-wrapper tbody  td > input.daterange-name-input',
  start_date1: 'tbody.custom-daterange-table-body > tr:nth-child(1)',
  start_date_input:
    'tbody.custom-daterange-table-body > tr:nth-child(1) > td > .daterange-start-anchor-input',
  date_apply_btn: 'button.applyBtn:visible',
  customdates_tbl: 'table#table-customdates',
  customdate_tbl_row: 'table#table-customdates tbody tr td:nth-child(2)',
  date_today: 'div.form-check input[value="TODAY"]:visible',
  customdates_dropdown: 'div.daterange-start-anchor-dropdown:visible',
  fixed_date_input: 'input[value="fixed-date"]:visible',
  table_vs: 'li#chart-table',
  shelves: {
    appShelves: {
      table_dimension: '#app-shelves ul#dimensions_shelf',
      dimensionItem: (name: string) =>
        `#app-shelves #dimensions_shelf .selection_field[title='${name}']`,
      table_measure: '#app-shelves ul#aggregates_shelf',
      filter_shelf: '#app-shelves [data-test-id="filters_shelf_list"]',
      x_shelf: '[data-test-id="x_shelf_list"]',
    },
    colorShelf: '#color_shelf',
  },
  removeButtonOnShelfItem: (shelfId: string, itemName: string) =>
    `${shelfId} li[data-test-id='color_shelf-app-shelf-item']:contains(${itemName}) .field-remove`,
  colorSettings: {
    colorpaletteSelectionNthItem: (index: number) =>
      `[data_setting_id='color_palette'] .settings-palette:nth-child(${index})`,
    nthColorBoxWithStyle: (index: number, style: string) =>
      `tr:nth-child(${index}) .single-color[style*="${style}"]`,
  },
  propertiesPanel: {
    backgroundColorMenu:
      '#properties-panel [data-test-id="properties-menu"] [data-category="data-bgcolor"]',
    backgroundColorMenuEnableButton: '#properties-panel [data-action="shelf-data-bgcolor"]',
    backgroundColorMenuColorShowPiece: '#properties-panel .settings-colorswatch-colors',
  },
  delete_custom_date_icon: (dateName: string) =>
    `table#table-customdates > tbody tr[data-test-item="${dateName}"] td.action-button-wrapper > a.delete`,
  filter_tab: 'a[data-target="#dash-filters-tab"]',
  filter_settings: 'li  a[data-tooltip-contents="Configure filter"]',
  filter_setting_modal: 'div.modal-dialog',
  custom_dates_fixed: 'td.open div.form-check input[name="fixed-time"]',
  custom_date_calendar: 'div#main  a#calendar-type',
  quick_filters: 'div.open div.dropdown-item.quick-filters-picked',
  custom_dates_calendar: 'div.show-calendar',
  custom_dates_settings_save: 'div.modal-dialog.modal-lg  button.settings-modal-save',
  quick_filter_option: 'div.quick-filters',
  fixed_date_input_txtbox: 'div.fixed-date input:eq(1)',
  date_from: 'input[name="daterangepicker_start"]',
  date_to: 'input[name="daterangepicker_end"]',
  filter_date_range: 'div.datetime-picker-filter-widget input.filter-date-range',
  date_dropdown: '.dropdown-menu:visible',
  dateItem: (itemName: string) => `[data-test-id="value-${itemName}"]`,
  // custom styles locators
  custom_styles_option: '.dropdown-menu a[href*="/customstyles"]',
  custom_styles: '.settings-tab-bottom a[href*="/customstyles"]',
  javascript_option: 'a[href*="#custom-js"]',
  js_ace_editor: '#style-js',
  js_text_area: '#style-js .ace_text-input',
  search: '.custom-css-search',
  delete_button: '.delete',
  dashboard: {
    visual_style_tab: '[data-test-id="visual-style-tab"] a[data-target="#dash-visual-style-tab"]',
    custom_visual_style_tab:
      '[data-test-id="dashboard-visual-style-sidebar"] [data-test-id="visual-style-option"][data-test-item="Custom Style"]',
    add_custom_style:
      '[data-test-id="dashboard-visual-style-sidebar"] [data-test-id="viz-customcss-addstyle"]',
    custom_style_checkbox: '.pickcss-list-item-cont  input[class*="custom-style-checkbox"]',
    table_header: '.dataTables_scroll .dataTables_scrollHead',
    search: '.custom-css-search',
    checkbox: '#pickcss-modal .style-name-select',
  },
  visual: {
    nthBarOnVisual: (index: number) => `.arc-bar-group:eq(${index}) rect`,
    search: '.custom-css-search',
    checkbox: '#pickcss-modal .style-name-select',
  },
};
