// MultiSheetDashboard Task06 Related Locators

export let locators = {
  error_indicator_visible: '.viz-error-msg:visible',
  sheet_title: 'li[class*="active"] .sheet-title',
  pickdashboard_modal_close: '.report-pick-modal button.close',
  visuals_sort: 'div.dataTables_scrollHead table thead th:nth-child(6)',
  results_list: '.app-title.dashboard-title-modal:visible',
  dashboard_stylemenu: 'a[data-target="#dash-basic-styling-tab"]',
  dimension_first_select: '[data-test-id="x_shelf-app-shelf-item"]:nth-child(1)',
  measure_first_select: '#app-shelves #y_shelf li[class="dropdown app-shelf-item"]:nth-child(1)',
  visual_subtitle: '[data-test-id="visual-list-item"] [data-test-id="arc-viz-subtitle"]',
  dash_basics: 'div#dashboard-styling-settings-sidebar > div[data-tabname="Dashboard Basics"]',
  dash_basics_labels:
    'div#dashboard-styling-settings-sidebar > div[data-tabname="Dashboard Basics"] label',
  dash_basics_textcolor:
    'div#dashboard-styling-settings-sidebar > div[data-tabname="Dashboard Basics"] label[title="Text Color"]',
  dash_basics_background:
    'div#dashboard-styling-settings-sidebar > div[data-tabname="Dashboard Basics"] label[title="Background Color"]',
  dash_basics_pgbackground:
    'div#dashboard-styling-settings-sidebar > div[data-tabname="Dashboard Basics"] label[title="Page Background Color"]',
  color_textbox:
    'div[class="sp-container sp-light sp-alpha-enabled sp-clear-enabled sp-palette-buttons-disabled sp-initial-disabled"] input.sp-input',
  color_ok_btn:
    'div[class="sp-container sp-light sp-alpha-enabled sp-clear-enabled sp-palette-buttons-disabled sp-initial-disabled"] button[class="sp-choose"]',
  dash_title: 'div#dashboard-styling-settings-sidebar > div[data-tabname="Dashboard Title"]',
  dash_title_font: 'div[data-setting-id="dashboard_title_font"] label',
  dash_title_arial_black: 'span.arc-font-arial-black',
  dash_title_font_size: 'div[data-setting-id="dashboard_title_font_size"]',
  dash_title_font_weight: 'div[data-setting-id="dashboard_title_font_weight"]',
  dash_title_bold: 'span.arc-font-weight-bold',
  dash_title_font_class: 'div[class="arc-dashboard-title-container arc-font-arial-black"]',
  dash_title_labels:
    'div#dashboard-styling-settings-sidebar > div[data-tabname="Dashboard Title"] label',
  dash_title_hidetitle_checkbox:
    'div[data-setting-id="dashboard_hide_title"] input[type="checkbox"]',
  dash_title_center_align: 'div.dashboard_title_alignment [data-test-id="radio-Center"]',
  dash_subtitle: 'div#dashboard-styling-settings-sidebar > div[data-tabname="Dashboard Subtitle"]',
  dash_subtitle_font: 'div[data-setting-id="dashboard_subtitle_font"] label',
  arial_black: 'span.arc-font-arial-black',
  dash_subtitle_fontsize: 'div[data-setting-id="dashboard_subtitle_font_size"]',
  dash_subtitle_font_size_class:
    'div[class="arc-dashboard-subtitle-container arc-font-arial-black"]',
  dash_subtitle_center_align: 'div.dashboard_subtitle_alignment [data-test-id="radio-Center"]',
  dash_subtitle_labels:
    'div#dashboard-styling-settings-sidebar > div[data-tabname="Dashboard Subtitle"] label',
  viz_basics:
    '[data-test-id="dashboard-visual-style-sidebar"] [data-test-id="visual-style-tab-Visual Basics"]',
  viz_font:
    '[data-test-id="dashboard-visual-style-sidebar"] [data-test-id="visual-style-tab-Visual Basics"] [data-setting-id="visual_font"] label',
  viz_arial: 'span.arc-font-arial',
  viz_basics_fontsize:
    '[data-test-id="dashboard-visual-style-sidebar"] [data-test-id="visual-style-tab-Visual Basics"] div[data-setting-id="visual_font_size"]',
  viz_basics_class:
    'div[class="arc-viz-container gridster-border arc-font-arial arc-viz-type-trellis-bars"]',
  viz_basics_bgcolor:
    '[data-test-id="dashboard-visual-style-sidebar"] [data-test-id="visual-style-tab-Visual Basics"] div[data-setting-id="visual_bg_color"] label',
  viz_border: 'div#dashboard-styling-settings-sidebar > div[data-tabname="Visual Borders"]',
  viz_border_chk: 'div[data-setting-id="borders_around_visuals"] input',
  viz_border_labels:
    'div#dashboard-styling-settings-sidebar > div[data-tabname="Visual Borders"] label',
  viz_border_radius: 'div[data-setting-id="visual_border_radius"] label ',
  color_dropdown: 'div.sp-replacer.sp-light',

  viz_title: '[data-test-id="dashboard-visual-style-sidebar"] [data-test-item="Visual Title"]',
  viz_title_font_label:
    '[data-test-id="dash-visual-style-tab"] div[data-setting-id="title_font"] label',
  viz_title_font: '[data-test-id="dash-visual-style-tab"] div[data-setting-id="title_font_size"]',
  viz_title_fontweight:
    '[data-test-id="dash-visual-style-tab"] div[data-setting-id="visual_title_font_weight"]',
  bar_visual: 'div.arc-viz-type-trellis-bars',
  viz_title_label:
    '[data-test-id="dashboard-visual-style-sidebar"] [data-test-id="tab-Visual Title"] label',
  viz_title_class_span:
    '[data-test-id="visual-list-item"] .arc-viz-title-container [data-test-id="arc-viz-title"]',
  viz_title_class: '[data-test-id="visual-list-item"] .arc-viz-title-container',
  viz_title_center_align:
    '[data-test-id="dashboard-visual-style-sidebar"] [data-test-id="visual-style-tab-Visual Title"] [data-test-id="radio-Center"]',

  visual_subtitle_style_setting:
    '[data-test-id="dashboard-visual-style-sidebar"] [data-test-item="Visual Subtitle"]',
  viz_subtitle_fontlabel:
    '[data-test-id="dash-visual-style-tab"] div[data-setting-id="subtitle_font"] label',
  viz_subtitle_fontsize:
    '[data-test-id="dash-visual-style-tab"] div[data-setting-id="subtitle_font_size"]',
  viz_subtitle_class_span:
    '[data-test-id="visual-list-item"] .arc-viz-subtitle-container [data-test-id="arc-viz-subtitle"]',
  viz_subtitle_txtclr:
    '[data-test-id="dash-visual-style-tab"] div[data-setting-id="visual_subtitle_fg"] label',
  viz_subtitle_bgclr:
    '[data-test-id="dash-visual-style-tab"] div[data-setting-id="visual_subtitle_bg"] label',
  viz_subtitle_centeralign:
    '[data-test-id="dash-visual-style-tab"] [data-test-id="visual-style-tab-Visual Subtitle"] [data-test-id="radio-Center"]',
  viz_subtitle_container: '[data-test-id="visual-list-item"] .arc-viz-subtitle-container',

  viz_axes_label:
    '[data-test-id="dashboard-visual-style-sidebar"] [data-test-item="Visual Axes and Labels"]',
  viz_axes_labels: (title: string) =>
    `[data-test-id="dashboard-visual-style-sidebar"] [data-test-id="visual-style-tab-Visual Axes and Labels"] label[title="${title}"]`,

  tooltips: '[data-test-id="dashboard-visual-style-sidebar"] [data-test-item="Tooltip"]',
  tooltips_font:
    '[data-test-id="dashboard-visual-style-sidebar"] div[data-setting-id="tooltip_font"] label',
  tooltips_font_size:
    '[data-test-id="dashboard-visual-style-sidebar"] div[data-setting-id="tooltip_font_size"]',

  filters: '[data-test-item="Filters"]',
  filter_setting_button: '[data-target="#dash-filters-tab"]',
  filter_labels: 'div#dashboard-styling-settings-sidebar > div[data-tabname="Filters"] label',
  filter_checkbox: 'div[data-setting-id="borders_around_filters"] input',
  filter_borders: 'div[data-setting-id="borders_around_filters"] input',
  custom_styles: 'a[href*="/apps/customstyles"]',
  new_custom_stylebtn: '.new-customstyle',
  custom_style_name: 'input#style-name',
  custom_style_desc: 'textarea#style-description',
  custom_style_area: 'div#style-css textarea',
  save_btn: 'button#save-link',
  visuals_side_tab: 'a[data-target="#dash-viz-tab"]',
  new_visual: 'a[class="btn btn-sm app-btn-highlight btn-new-visual"]',
  segments: 'a[href="#segments"]',
  new_segment: 'a#segment-create',
  segment_popup: 'div#viz-segment-create',
  segment_name: 'input#viz-segment-create-name',
  segment_filter: 'input#viz-segment-default',
  filter_expr: 'ul#viz-segment-filters input',
  filter_element: (shelfType: string, fieldName: string) =>
    `#dash-filters-tab [data-test-id='${shelfType}-app-params'] [data-test-id='selection-field-item']:contains(${fieldName})`,
  segment_expr_popup:
    'div[class="modal-content edit-expression-holder ui-draggable"] h4#sql-expr-title',
  segment_filter_expr: 'textarea[class="ace_text-input"]',
  apply_btn: 'button#sql-expr-apply',
  save_segment_button: 'button#viz-segment-save',
  segment_row: 'table#segments-table tbody tr td:nth-child(3)',
  validate_btn: 'div#sql-expr-edit button.viz-validate-btn',

  settings_tab: '[data-test-id="visual-settings-tab-a"]',
  parameters_tab: '[data-tabname="Parameters"] [data-test-item="Parameters"]',
  explicit_data_checkbox: 'div[data-setting-id="explicit_scope"] input',

  custom_style_tab: '[data-test-id="dash-visual-style-tab"] [data-test-item="Custom Style"]',
  add_custom_style:
    '[data-test-id="dash-visual-style-tab"] [data-test-id="viz-customcss-addstyle"]',
  pick_css_modal: 'div#pickcss-modal',
  pick_css_heading: 'div#pickcss-modal h4',
  custom_style_select: 'div#pickcss-modal div.modal-body input',
  css_add_button:
    'div#pickcss-modal div.modal-footer button[class="btn btn-primary customcss-add"]',
  style_table:
    '[data-test-id="dash-visual-style-tab"] [data-test-id="visual-style-tab-Custom Style"] table',
  style_table_name:
    '[data-test-id="dash-visual-style-tab"] [data-test-id="visual-style-tab-Custom Style"] table tr td:nth-child(2)',
  custom_style: 'ul#settings-tabs li a[href*="/customstyles"]',
  style_tbl: 'table#table-customstyles',
  stlyle_tbl_name: 'table#table-customstyles td:nth-child(2)',
  color_tab: '[data-test-id="visual-style-option"][data-test-item="Colors"]',
  color_palette_10th: '[data-test-id="settings-palette"]:nth-child(10)',
  color_palette_color_boxes: '.settings-swatch',
  dash_panel: 'div.dash-main-panel',
  dashboardSettingPanel: {
    filterSection: '.dash-settings-panel .filters_tab_selection_item',
  },
  dash_applist: 'div#app-selected-list',
  dash_container: 'div.control-container',
  dashboard_title: 'div#dashboard-title',
  dashboard_container: 'div.arc-dashboard-title-container',
  dashboard_subtitle: 'div#dashboard-subtitle',
  dash_subtitle_container: 'div.arc-dashboard-subtitle-container',
  tooltip_popup: 'div.contextmenu-hdr table',
  site_png_download: 'div[data-setting-id="site_png_download_on"] input',
  enable_email: 'div[data-setting-id="email_enabled"] input',
  test_email_btn: '[data-test-id="site_settings_test_email_btn"]',
  dashboard_sheets: 'ul.dashboard-sheet-handles > li',
  add_to_favorites: '#report-menu-list .myapp-addremove-link',
  set_as_homepage: '#report-menu-list .set-homepage-link',
  export: '#report-menu-list .export-my-viz',
  new_dashboard: '#report-menu-list .newdashboard-link',
  delete_dashboard: '#report-menu-list a.delete-db-link',
  select_dashboard: 'table#report-table tr td.table-app-title span[title="dashTitle"]',
  export_file_name: 'input#export-visual-filename',
  export_button: 'button#viz-dash-export-confirm',
  export_close_button: '#export-visuals-modal .modal-footer > :not(.btn-primary)',
  download_as: 'ul#report-menu-list > li > ul > li:nth-child(index)',
  visual_tab_ellipsis: '.subnav-report .report-menu-list .dropdown .fa.fa-ellipsis-h',
  smart_acceleration: '[data-test-id="accelerate-button"]',
  recommendation: 'table#app-accel-table tbody tr:nth-child(2) span.label-info',
  get_url: "div[class='viz-params-control'] a.viz-params-link",
  dash_url_modal: '#link-modal div.modal-content',
  dash_url_modal_buttons: '#link-modal div.modal-footer button.btn',
  limit: '.app-limit-container .limit-input',
  view_mode: '.view-link',
  edit_link: "[data-test-id='report-menu-list-editapp-link']",
  visual_select_specific:
    "[data-test-id='main-app-arc-app-container'] [data-test-id='visual-list-item']:nth-child(index)",

  dashboard: {
    sheet: {
      handle: (index: number) => `li[data-test-id^="sheet-number"]:eq(${index - 1})`,
      handle_caret: (index: number) =>
        `li[data-test-id^="sheet-number"]:eq(${index - 1}) [data-test-id="sheet-caret"]`,
      title: (index: number) => `li[data-test-id^="sheet-number"]:eq(${index - 1}) .sheet-title`,
      menuRename: '.sheet-rename',
      menuClone: '.sheet-clone',
      menuDelete: '.sheet-delete',
      menuMoveRight: '.sheet-move-right',
      menuMoveLeft: '.sheet-move-left',
    },
  },
};
