const extractTarget: string = Cypress.env('dataExtractsTarget');

// for local testing:
const extractTargetSqlite = {
  test_db_name: 'main',
  connection_type: 'SQLite',
  connection_name: 'extractsTargetSQLite',
  filename: extractTarget,
};

// for CI testing:
const extractTargetPostgres = {
  test_db_name: 'public',
  connection_type: 'PostgreSQL',
  connection_name: 'extractsTargetPostgres',
  hostname: Cypress.env('dataExtractsTarget'),
  port: '15432',
  database: 'postgres',
  username: 'postgres',
  password: 'cloudera',
  advanced: {
    sock_type: 'normal_sock_type',
  },
};

export const extractTargetDb = extractTarget.includes('sqlite')
  ? extractTargetSqlite
  : extractTargetPostgres;
