// Dataset Management Locators

export let locators = {
  sidebar: 'div > div.sidebar > ul > li',
  fields: 'a[href="#attributes"]',
  editField: '#edit-attr-btn',
  attributes: '#attributes',
  saveEditFields: '#save-attr-btn',
  fieldsList: '.table-list-value-edit',
  fieldExpressionTab: '#expression-tab>a',
  expressionEditor: '#expression',
  editColumnModal: '#edit-column-modal',

  // Data Model locators
  dataModel: "a[href='#sources']",
  editJoin: '#edit-join-btn',
  saveJoin: '#save-join-btn',
  joinSelect: '[dataset-test-id="addtable-dataset-create-commit"]',
  joinAddTbDsCancel: '[dataset-test-id="addtable-dataset-cancel"]',
  applyJoin: '#edit-join-apply',
  databaseName: '[data-test-id="addtable-dataset-dbname"]',
  tablename: '[data-test-id="addtable-dataset-tablename"]',
  showdata: '#show-data-btn',
  // vizJoinImage: '#viz-join > image',
  vizJoinImage: '.join-image',
  deleteJoinBtn: '[arcid="join-content-popover-active"] [arcid="delete-join-link-button"]',
  editJoinModal: '[data-test-id="edit-join-modal"]',
  joinAddTbDsLoadingSpinner: '[data-test-id="addtable-dataset-loading-spinner"]',
  editJoinLoadingSpinner: '[data-test-id="join-sample-column-loading-spinner"]',
  vizJoinDiv: '[data-test-id="viz-join"]',
  editJoinTargetLbl: '[data-test-id="edit-join-target-lbl"]',
  joinTableBox: '[data-test-id="join-table-box"]',
  addJoin: (databaseName: string, tableName: string) =>
    `[data-original-title="${databaseName}.${tableName}"][data-test-id="join-table-box"] [data-test-id="dataset-add-table"]`,

  // Segment locators
  segments: "a[href='#segments']",
  newSegmentBtn: '#segment-create',
  addSegementModalHeader: '#viz-segment-create-title',
  segmentName: '#viz-segment-create-name',
  segmentGroup: '#viz-segment-create-group',
  segmentFilters: '#viz-segment-filters > li > .form-control',
  segementSaveBtn: '#viz-segment-save',
  segFilterExprEdit: "#sql-filter-expr textarea[class='ace_text-input']",
  segFilterExpr: '#sql-filter-expr',
  segFilterExprValidateBtn: '#sql-expr-edit .edit-expression-textbox button.expression-validate',
  expressionApply: '#sql-expr-apply',
  segListTableRows: '#segments-table > tbody > tr',

  // Search modeling
  searchModeling: "a[href='#dataset-search']",
  enableSearchCB: '#dataset-search input#searchenabled',
  searchGroupTB: '#dataset-search #search-group',
  defaultAggDropdown: '#dataset-search select#default-agg',
  saveSearchModelBtn: '#dataset-search #save-search',
  undoSearchModelBtn: '#dataset-search #undo-search',
  columnsTableRow: '#dataset-search #search-table tbody tr',
  addSuggestedQuestionBtn: '#search-suggestions tr:last td a',
  addWordExpansionBtn: '#search-words tr:last td a',
};
