import { Dashboard, ShelfTypes, SortOptions } from 'lib/dashboard/dashboards_interfaces';

export function saveExpression(fieldDetail: any) {
  const colName = fieldDetail.field_name;
  const shelf = fieldDetail.field_shelf;
  const shelfDropdownLocator = '#' + shelf + ' .dropdown';
  const shelfLocator = '#' + shelf;

  cy.get(shelfDropdownLocator)
    .contains(colName)
    .click({ force: true });
  cy.get('#properties-panel ul.properties-menu.noselect')
    .contains('Save Expression')
    .click({ force: true });
  cy.get('#derived-data-modal .modal-content').within(() => {
    cy.get('#dd-name-input').type(fieldDetail.dd_name);
    cy.get("input[value='" + fieldDetail.dd_type + "']").click();
    cy.get('#create-deriveddata-save').click();
  });
  let colTypeLocator = '';
  switch (shelf) {
    case ShelfTypes.DIMENSIONS:
      colTypeLocator = 'derived-data-dims-wrapper';
    case ShelfTypes.AGGREGATES:
      colTypeLocator = 'derived-data-aggs-wrapper';
  }
  cy.get(shelfLocator).should('contain', colName);
  cy.wait(3000);
  // to close the panel
  cy.get(shelfDropdownLocator)
    .contains(colName)
    .click();
  // cy.wait(3000);
}

export function removeField(fieldShelf: string, colName: string) {
  const shelfDropdownLocator = '#' + fieldShelf + ' .dropdown';

  cy.get(shelfDropdownLocator)
    .contains(colName)
    .click();
  cy.get('#properties-panel ul.properties-menu.noselect .app-shelf-remove').click();
}

export function addField(fieldShelf: string, colName: string) {
  const shelfLocator = '#' + fieldShelf;
  cy.get(shelfLocator).each(($el) => {
    $el.click();
  });
  const fieldLocator = "#visual-data-panel .app-params .selection_field[title='" + colName + "']";
  cy.get(fieldLocator)
    .scrollIntoView()
    .click();
}

export function deleteDerivedDataAggField(fieldName: string) {
  const fieldLocator =
    "#visual-data-panel .app-params.agg-app-params .selection_field[title='" + fieldName + "']";
  cy.get(fieldLocator)
    .parent()
    .get('.dropdown-toggle.derived-caret')
    .first()
    .click({ multiple: true });
  cy.get('#visual-data-panel .app-params.agg-app-params .del-view-popover')
    .first()
    .click({
      multiple: true,
    });
  cy.get('#delete-deriveddata-modal').within(() => {
    cy.wait(5000);
    cy.get('#delete-deriveddata-yes').click({ force: true });
  });
  cy.wait(3000);
}

export function deleteDerivedDataDimField(fieldName: string) {
  const fieldLocator =
    "#visual-data-panel .app-params.dim-app-params .selection_field[title='" + fieldName + "']";
  cy.get(fieldLocator)
    .parent()
    .get('.dropdown-toggle.derived-caret')
    .first()
    .click({ multiple: true });
  cy.get('#visual-data-panel .app-params.dim-app-params .del-view-popover')
    .first()
    .click({
      multiple: true,
    });
  cy.get('#delete-deriveddata-modal').within(() => {
    cy.wait(5000);
    cy.get('#delete-deriveddata-yes').click({ force: true });
  });
  cy.wait(3000);
}
