
import * as visual_common_test from 'lib/visual/visual_common_tests';
import * as functions from 'lib/functions';
import { CSSselector } from 'locators';

export function drillIntoBar(drillIntoFieldName: string, barLabel: string, hasColor: boolean = false) {
  visual_common_test.triggerUserActionOnSpecificBarOnBarVisual(barLabel, visual_common_test.userActionTypes.click, hasColor);
  drillIntoField(drillIntoFieldName);
}

export function drillIntoField(drillIntoFieldName: string) {
  cy.get(`${CSSselector.contextmenu_dropdown}:contains('Drill Into')`, {timeout : 10000}).trigger('mouseover');
  cy.get(`${CSSselector.contextmenu_dropdown} li a`).each(($el, index) => {
    if ($el.text() === drillIntoFieldName) {
      cy.get(`${CSSselector.contextmenu_dropdown} li a[data-col=${index}]`).click();
    }
  });

  // wait for run to finish
  functions.loadingSpinnerCheck(`[data-test-id='visual-list-item']:nth-child(1) ${CSSselector.loading_bar}`);
}

export function drillIntoBarDBView(drillIntoField: string) {
  cy.intercept('POST', '/arc/sqlrun/jsonselect_parallel_async/*').as('jsonselect_parallel');
  cy.wait(1000);
  cy.get('#app-selected-list g.viz-bar-g rect').click({ force: true });
  cy.wait(1000);
  cy.get('div.contextmenu-foot div.dropdown-on-hover').trigger('mouseover');
  cy.get('.dropdown-on-hover li a').each(($el, index, $list) => {
    if ($el.text() === drillIntoField) {
      cy.get(`.dropdown-on-hover li a[data-col=${index}]`).click();
    }
  });
  cy.wait('@jsonselect_parallel');
}

export function verifyShelf(shelf: string, items: object) {
  let counter = 0;
  if (items != null) {
    // tslint:disable-next-line:forin
    for (const item in items) {
      counter++;
    }
  }

  let selector = '';
  console.log('Defining the selector for shelf :' + shelf);
  switch (shelf) {
    case 'x':
      selector = '#app-shelves #x_shelf .selection_field';
      cy.log('shelf selector: ' + selector);
      break;
    case 'color':
      selector = '#app-shelves #color_shelf .selection_field';
      cy.log('shelf selector: ' + selector);
      break;
    case 'filters':
      selector = '#app-shelves #filters_shelf .selection_field';
      cy.log('shelf selector: ' + selector);
      break;
  }

  // verify the number of items in shelf are correct
  if (counter !== 0) {
    cy.get(selector).should('have.length', counter);
  }

  if (selector !== '') {
    for (const key in items) {
      cy.get(`${selector}:contains("${key}")`);
    }
  }
}
