import { CSSselector } from 'locators/common/CSSselector';

/**
 * given a visual number , go to visual and schedule a email based on emails.json
 *
 * @export
 * @param {any} visualNumber
 */
export function scheduleEmail(visualNumber: number) {
  cy.intercept('POST', '/arc/reports/report/*').as('visualSubmitted');
  cy.get(CSSselector.visual_edit_specific(visualNumber)).click({
    force: true,
  });
  cy.get(CSSselector.bar_visual).click();
  cy.get(CSSselector.vizual_fields_tab.replace('column-name', 'ctyname')).click();
  cy.get(CSSselector.measure_field).click();
  cy.get(CSSselector.vizual_fields_tab.replace('column-name', 'state')).click();
  cy.get(CSSselector.visual_title_specific(visualNumber))
    .click()
    .type('Bar Visual Title');
  cy.get(CSSselector.refresh_visual).click();
  cy.get(CSSselector.save_visual).click();

  cy.wait('@visualSubmitted')
    .its('response.statusCode')
    .should('eq', 200);

  cy.get('#chart-1 > svg > g > text.x.arc-viz-axis-label').should('contain', 'ctyname');
  cy.get('#chart-1 > svg > g > text.y.arc-viz-axis-label').should('exist');
  cy.get("div[class$='bars']").should('be.visible');
  cy.get('.dash-viz-wrapper [class="y arc-viz-axis-label"]').should('exist');
  cy.get('#app-selected-list [class="x arc-viz-axis-label"]').should('have.text', 'ctyname');
}
