/**
 * Verify hash of a visual after visual creation
 * @param hash : hash value of a visual
 */
export function verifyVisualHash(
  hash: string | string[],
  canvaslocator = 'div.dash-viz-wrapper canvas.maincanvas'
) {
  cy.document().then(($doc) => {
    if (!$doc) {
      return;
    }
    const context = ($doc.querySelector(canvaslocator) as HTMLCanvasElement).getContext('2d');
    expect((context as any).hash({ loose: true })).to.eq(hash);
  });
}
