// ***********************************************************
// This example support/index.js is processed and
// loaded automatically before your test files.
//
// This is a great place to put global configuration and
// behavior that modifies Cypress.
//
// You can change the location of this file or turn off
// automatically serving support files with the
// 'supportFile' configuration option.
//
// You can read more here:
// https://on.cypress.io/configuration
// ***********************************************************

// Import commands.js using ES2015 syntax:
// ***********************************************************
// This example support/index.js is processed and
// loaded automatically before your test files.
//
// This is a great place to put global configuration and
// behavior that modifies Cypress.
//
// You can change the location of this file or turn off
// automatically serving support files with the
// 'supportFile' configuration option.
//
// You can read more here:
// https://on.cypress.io/configuration
// ***********************************************************
import '@frsource/cypress-plugin-visual-regression-diff';
import 'cypress-mailhog';
import addContext = require('mochawesome/addContext');

Cypress.on('test:after:run', (test, runnable: Suite) => {
  if (test.state === 'failed') {
    const screenshotPath = Cypress.spec.relative.replace(/^cypress\/tests\//, '');

    const screenshot = `../../screenshots/${screenshotPath}/${getSuitePath(
      runnable.parent
    )} -- ${sanitize(test.title)} (failed).png`;
    console.log('screenshot', screenshot);
    addContext({ test }, screenshot);
  }
});

interface Suite {
  title: string;
  parent: Suite;
}

function getSuitePath(runnable: Suite) {
  const path = [];
  while (runnable.title) {
    path.push(runnable.title);
    runnable = runnable.parent;
  }
  let pathStr = path.reverse().join(' -- ');
  pathStr = sanitize(pathStr, [/\./g]);
  return pathStr;
}

function sanitize(testTitle: string, extraPatterns: RegExp[] = []) {
  const patterns = [/\//g, /\?/g, /\</g, /\>/g, /\\/g, /:/g, /\*/g, /\|/g, /"/g];

  patterns.concat(extraPatterns).forEach((p) => {
    testTitle = testTitle.replace(p, '');
  });
  testTitle = testTitle.trim();

  testTitle = testTitle.replace('#', '%23');

  return testTitle;
}
Cypress.on('window:before:load', (win) => {
  return;
});
