import * as functions from 'lib/functions';
import { CSSselector } from 'locators/common/CSSselector';

interface RoleInfo {
  roleName: string;
  roleDescription: string;
  user_list: string[];
}

declare global {
  namespace Cypress {
    interface Chainable {
      addRole: (roleInfo: RoleInfo) => void;
      addPermissions: (privilegeInfo: { connections: string }, permissionInfo: any) => void;
      deleteComponentFromRole: (component: any, permissionInfo: any) => void;
      editRoles: (roleName: string, roleInfo: RoleInfo) => void;
      deleteRoles: (roleName: string) => void;
    }
  }
}
