export function dragAndDrop(draggableSelector: string, droppableSelector: string) {
  cy.get(draggableSelector).then(($draggable) => {
    cy.get(droppableSelector).then(($droppable) => {
      const dragPos = $draggable.offset();
      const dropPos = $droppable.offset();
      const dragRect = $draggable[0].getBoundingClientRect();
      const dropRect = $droppable[0].getBoundingClientRect();
      if (dragPos && dropPos) {
        cy.get(draggableSelector)
          .trigger('mousedown', {
            which: 1,
            pageX: dragPos.left + dragRect.width / 2,
            pageY: dragPos.top + dragRect.height / 2,
            force: true,
          })
          .trigger('mousemove', {
            which: 1,
            pageX: dropPos.left + dropRect.width / 2,
            pageY: dropPos.top + dropRect.height / 2,
            force: true,
          })
          .trigger('mouseup');
      }
    });
  });
}
