import { locators } from './locators';

// import * as visual from 'lib/visual';
export enum FontSizeSettingTestOptions {
  SET_VISUAL_FONTSIZE = 'set all fontsize on visual',
  SET_VISUAL_TITLE_FONTSIZE = "set visual's title font size",
  SET_VISUAL_SUBTITLE_FONTSIZE = "set visual's subtitle font size",
  SET_AXIS_LABEL_FONTSIZE = 'set axis label fontsize',
  SET_AXIS_TICKS_FONTSIZE = 'set axis ticks font size',
  SET_TRELLIS_LABEL_FONTSIZE = 'set trellis label font size',
  SET_LEGEND_FONTSIZE = 'set legend font size',
}

interface IFontSizeSetting {
  styleSettingLocators: {
    subsection: string;
    fontSizeSetter: string;
  };
  effectedElementLocator: string;
}

export const FontSizeTestHelperMap = new Map<FontSizeSettingTestOptions, IFontSizeSetting>([
  [
    FontSizeSettingTestOptions.SET_VISUAL_FONTSIZE,
    {
      styleSettingLocators: {
        subsection: locators.style.basicSelector,
        fontSizeSetter: locators.style.basicFontSize,
      },
      effectedElementLocator: locators.x_axis_values,
    },
  ],

  [
    FontSizeSettingTestOptions.SET_VISUAL_TITLE_FONTSIZE,
    {
      styleSettingLocators: {
        subsection: locators.style.titleSelector,
        fontSizeSetter: locators.style.titleFontSizeSelector,
      },
      effectedElementLocator: locators.viz_title_class_span,
    },
  ],
  [
    FontSizeSettingTestOptions.SET_VISUAL_SUBTITLE_FONTSIZE,
    {
      styleSettingLocators: {
        subsection: locators.style.subtitleSelector,
        fontSizeSetter: locators.style.subtitleFontSize,
      },
      effectedElementLocator: locators.viz_subtitle_class_span,
    },
  ],

  [
    FontSizeSettingTestOptions.SET_AXIS_LABEL_FONTSIZE,
    {
      styleSettingLocators: {
        subsection: locators.style.axisSelector,
        fontSizeSetter: locators.style.axisLableFontSize,
      },
      effectedElementLocator: locators.y_axis_labels,
    },
  ],

  [
    FontSizeSettingTestOptions.SET_AXIS_TICKS_FONTSIZE,
    {
      styleSettingLocators: {
        subsection: locators.style.axisSelector,
        fontSizeSetter: locators.style.axisTicksFontSize,
      },
      effectedElementLocator: locators.visual.ticks,
    },
  ],

  [
    FontSizeSettingTestOptions.SET_TRELLIS_LABEL_FONTSIZE,
    {
      styleSettingLocators: {
        subsection: locators.style.axisSelector,
        fontSizeSetter: locators.style.trellisFontSize,
      },
      effectedElementLocator: locators.visual.trellis,
    },
  ],

  [
    FontSizeSettingTestOptions.SET_LEGEND_FONTSIZE,
    {
      styleSettingLocators: {
        subsection: locators.style.axisSelector,
        fontSizeSetter: locators.style.legendFontSize,
      },
      effectedElementLocator: locators.visual.legendLabels,
    },
  ],
]);
