// Visuals related locators

export let locators = {
  viz_title_class_span:
    '[data-test-id="visual-list-item"] .arc-viz-title-container [data-test-id="arc-viz-title"]',
  viz_title_containing: (text: string) => `[data-test-id="arc-viz-title"]:contains(${text})`,
  viz_container: '.arc-viz-container',
  viz_chart: '.viz-chart',
  viz_subtitle_class_span:
    '[data-test-id="visual-list-item"] .arc-viz-subtitle-container [data-test-id="arc-viz-subtitle"]',
  shelf_labels: 'div.shelves-wrapper div.shelf-label span.shelf-description',
  x_axis_labels: '.dash-viz-wrapper .x.arc-viz-axis-label',
  y_axis_labels: '.dash-viz-wrapper .y.arc-viz-axis-label',
  visual_icons: '#chart-type-menu li',
  interactive_map_visual: 'canvas.leaflet-heatmap-layer.leaflet-layer.leaflet-zoom-animated',
  box_plots_dash_view: '',
  box_plots_visual_view: '.dash-viz-wrapper g > rect',
  x_axis_values: 'div.dash-viz-wrapper svg > g.x.arc-viz-axis > g.tick > text',
  x_axis_value_g: 'div.dash-viz-wrapper svg > g.x.arc-viz-axis > g.tick',
  y_axis_values: 'div.dash-viz-wrapper svg g.y.arc-viz-axis > g.tick > text',
  y_axis_value_g: 'div.dash-viz-wrapper svg g.y.arc-viz-axis > g.tick',
  horizontal_box_plot: "div[data-setting-id='horizontalBoxplots']",
  full_size: '#app-selected-list a.glyphicon-resize-full',
  workspace: '.in-dashboard .viz-workspace-wrapper',
  dash_ellipsis: '#report-menu-list .more-btn .fa.fa-ellipsis-h',
  show_usage_info: '#report-menu-list .show-audit-logs',
  perf_modal: {
    profile_tab: '#perf-modal .perf-contents .nav-tab-profile',
    current_load_tab: '#perf-modal .perf-contents .nav-tab-current-load',
    layout_tab: '#perf-modal .perf-contents .nav-tab-layout',
    queries_tab: '#perf-modal .perf-contents .nav-tab-queries',
    historical_logs_tab: '#perf-modal .perf-contents .nav-tab-usage',
    clone_info_tab: '#perf-modal .perf-contents .nav-tab-clones',
    downloadQueries_btn: '#perf-modal .perf-contents .queries-download',
  },
  link_viz_table: 'tbody.linked-visual-table',
  visual: {
    svg: '.dash-viz-wrapper table.viz-trellis-table tr .viz-trellis-div > div > svg',
    y_axis: '.dash-viz-wrapper g.y.arc-viz-axis',
    x_axis: '.dash-viz-wrapper g.x.arc-viz-axis',
    trellis: '.dash-viz-wrapper tr.viz-tr-header td.viz-td-header',
    ticks: 'g.arc-viz-axis g.tick text',
    table: '.dash-viz-wrapper .viz-trellis-table',
    grid_line: 'g.y.viz-bar-axis-grid',
    grid_lines:
      '.dash-viz-wrapper table.viz-trellis-table tr .viz-trellis-div svg > g > g.y.viz-bar-axis-grid',
    segment_modal: '#filter-pick-modal',
    segment_picker: '#properties-panel a.values-picker-link',
    segment_values: '#filter-pick-values .filter-value-checkbox',
    filter_segment_save: '#filter-pick-save',
    legendLabels: '.arc-legend-container g.small-legend text.arc-legend-label',
  },
  animation: {
    controller: '.dash-viz-wrapper .viz-transition-controls',
    play: 'div#app-selected-list span > i.fa-play',
    pause: 'div#app-selected-list span > i.fa-pause',
    fast_back: 'div#app-selected-list span > i.fa-fast-backward',
    back: 'div#app-selected-list span > i.fa-step-backward',
    fast_forward: 'div#app-selected-list span > i.fa-fast-forward',
    forward: 'div#app-selected-list span > i.fa-step-forward',
    value: '#app-selected-list .viz-transition-controls span:nth-of-type(1)',
  },

  settingUserControl: 'settings-user-control',
  style: {
    basicSelector: "#dash-visual-style-tab > div > div[data-tabname='Visual Basics']",
    basicFontType: "div[data-setting-id='visual_font']",
    basicFontSize: "div[data-setting-id='visual_font_size']",
    dropDownSelector: "button[data-toggle='dropdown']",
    titleSelector: "#dash-visual-style-tab > div > div[data-tabname='Visual Title']",
    titleFontSelector: "div[data-setting-id='title_font']",
    titleFontSizeSelector: "div[data-setting-id='title_font_size']",
    visualTitleFontWeight: "div[data-setting-id='visual_title_font_weight']",
    visualTitleFontAlignment: "div[data-setting-id='title_alignment']",
    visualTitleHide: "div[data-setting-id='visual_hide_title']",
    subtitleSelector: "#dash-visual-style-tab > div > div[data-tabname='Visual Subtitle']",
    subtitleFontSelector: "div[data-setting-id='subtitle_font']",
    subtitleFontSize: "div[data-setting-id='subtitle_font_size']",
    subtitleFontAlignment: "div[data-setting-id='subtitle_alignment']",
    tooltipSelector: "#dash-visual-style-tab > div > div[data-tabname='Tooltip']",
    tooltipFontSelector: "div[data-setting-id='tooltip_font']",
    tooltipFontSize: "div[data-setting-id='tooltip_font_size']",
    axisSelector: "#dash-visual-style-tab > div > div[data-tabname='Visual Axes and Labels']",
    axisLableFontSize: "div[data-setting-id='axis_label_font_size']",
    axisTicksFontSize: "div[data-setting-id='axis_ticks_font_size']",
    trellisFontSize: "div[data-setting-id='trellis_font_size']",
    legendFontSize: "div[data-setting-id='legend_font_size']",
    trendlines: 'line.viz-trendline',
    colors: {
      tab: '[data-test-id="tab-Colors"]',
      reverseColorPaletteCheckbox: '[data_setting_id="color_palette"] input#colorPalettes',
      opacitySliderInput: '[data_setting_id="color_opacity"] input',
      secondColorPalatte4thColor:
        '[data-test-id="colorpalettes-setting"] .settings-palette:nth-child(2) .settings-swatch:nth-child(4)',
      firstColorWithinPaletteInfo: '[data-test-id="visual-style-tab-Colors"] .first-color',
      fixColorForSpecifiedCheckbox: '[data-test-id="fix-color-for-specified-checkbox"]',
      selectedColorPalettesColorBoxes: '.settings-palette.settings-color-selected .settings-swatch',
      useDatasetColorSettingCheckbox:
        '[data-test-id="setting-id-use_dataset_color_settings"] input',
      fixDimensionColorsCheckbox: '[data-setting-id="dim_to_color_mapping"] input',
    },
  },
  dataConnection: {
    selectConnection: '#dash-viz-tab > form > div:nth-child(1) > div > div',
    selectDataset: '#datasource-modal form > div:nth-child(2) > div > div',
  },
  boxplot: {
    boxes: '[data-test-id="main-app-arc-app-container"] .viz-trellis-div svg > g > rect',
    intervalLines: '[data-test-id="boxplot-box-item"] > [data-test-id="whiskers"]',
    alert: '.dash-main-panel .alert-warning',
  },
  richText: {
    bold: '.note-icon-bold',
    italic: '.note-icon-italic',
    underline: '.note-icon-underline',
    strikethrough: '.note-icon-strikethrough',
    superscript: '.note-icon-superscript',
    subscript: '.note-icon-subscript',
    codeView: '.note-icon-code',
    body: 'div.note-editable',
  },

  visualTypeSelectors: {
    bar_visual: '#chart-trellis-bars',
    line_visual: '#chart-trellis-lines',
    scatter_visual: '#chart-scatter',
    bar_line_visual: '#chart-combo',
    area: '#chart-trellis-areas',
    pie: '#chart-pie', //
    KPI: '#chart-kpi',
    gauge: '#chart-gauge', //
    list: '#chart-list',
    bullet: '#chart-bullet',
    boxplot: '#chart-boxplot', //
    flow: '#chart-flow',
    funnel: '#chart-funnel',
    radial: '#chart-radial', //
    chord: '#chart-chord', //
    packedBubbles: '#chart-packed-bubbles', //
    wordcloud: '#chart-wordcloud', //
    network: '#chart-network',
    dendogram: '#chart-dendogram', //
    treemap: '#chart-treemap', //
    corelation: '#chart-corelation', //
    corelationFlow: '#chart-corelation-flow', //
    map: '#chart-map', //
    calendarHeatMap: '#chart-calendar-heat-map', //
    leaflet: '#chart-leaflet', //
    sparklines: '#chart-sparklines', //
    search: '#chart-search',
    link: '#chart-link',
    timeline: '#chart-timeline', //
    histogram: '#chart-histogram',
    action: '#chart-action',
    extension: '#chart-extension',
    html: '#chart-html',
    columnStats: '#chart-column-stats',
    rawtable: '#chart-rawtable',
    crosstab: '#chart-crosstab', //
  },
};
