import { logins } from 'lib/arctest';
import * as connections from 'lib/connections';
import { TEST_CONNECTIONS } from 'lib/connections/connections';
import { navigate_to_visuals, skipIfCDW } from 'lib/functions';

describe('Arcviz Connection Test Suites.', () => {
  before(() => {
    cy.fixture('users.json').then((data) => {
      logins.silent(data.admin.username, data.admin.password);
    });

    navigate_to_visuals();
  });

  function isSQLiteOrDuckDB(connectionType: string) {
    return ['SQLite', 'DuckDB'].includes(connectionType);
  }

  Object.values(TEST_CONNECTIONS).forEach((tc: any) => {
    it(`can create connection of type ${tc.connection_type}: ${tc.connection_name}`, function() {
      if (isSQLiteOrDuckDB(tc.connection_type)) {
        skipIfCDW(this);
      }
      if (tc.connection_name.includes('kerberos')) {
        skipIfCDW(this);
      }
      connections.createConnection(tc);
    });
  });
});
