import { jobs } from 'fixtures/locators/jobs';
import { logins } from 'lib/arctest';
import * as functions from 'lib/functions';
import { createEmailJob, JobType } from 'tests/jobs/utils';

describe('Job logs', () => {
  before(() => {
    logins.silent();
  });

  it('Delete job log', () => {
    createEmailJob(JobType.Scheduled);
    functions.goToJobSchedulePage();

    cy.get(`${jobs.job_overview.jobs_table} > tbody > tr`)
      .eq(0)
      .find(jobs.job_overview.jobs.actions)
      .click();
    cy.get(jobs.job_overview.jobs.run_now).click();
    cy.wait(500);
    cy.get(jobs.bulk_actions.run).click();
    cy.get(jobs.job_overview.runs_tab).click();

    cy.get(`${jobs.job_overview.runs_table} tbody tr:first-child ${jobs.job_overview.runs.select_log}`).click();

    cy.get(jobs.job_overview.bulk_delete_runs).click();

    cy.get(jobs.bulk_actions.delete)
      .should('be.not.disabled')
      .then(() => {
        functions.modalClick(jobs.bulk_actions.delete);
      });
  });
});
