import * as apps from 'lib/apps';
import * as arctest from 'lib/arctest';
import * as dashboard from 'lib/dashboard/dashboard_functions';
import * as filter from 'lib/filter';
import * as functions from 'lib/functions';
import * as imp_exp from 'lib/import_export';
import * as visual from 'lib/visual';
import { CSSselector } from 'locators/common/CSSselector';

describe('Import Veliko App and Verify appscope of Event Filter as well as verify visuals and filters parameters by applying 3 different values of filters with exclude, forward, backward and reset filters.', () => {
  const filterName = 'Event Filter';
  const eventFilter = [
    'IN-STORE: BILLING ISSUE',
    'ONLINE: BILL PAY ISSUE',
    'QOS: CALL QUALITY ISSUE',
  ];
  const dashboardName = [
    'Clone of VELIKO - Customer Cost Details',
    'Clone of VELIKO - Fiscal Year - Customer Service Quality / Cost Dashboard',
    'Clone of VELIKO Campaign Inspector',
    'Clone of VELIKO - Subscriber Churn Analysis - Napoli',
  ];
  const appFile = 'Veliko.json';
  const appName = 'Veliko';
  const churnVisual = {
    visualType: '.chart-icon-corelation',
    visual1: {
      visualPosition: 9,
      hash: '1d9d3e11783d7ecb8336e208cc51db7a',
      IS: [
        'setTransform',
        'translate',
        'globalAlpha',
        'lineWidth',
        'strokeStyle',
        'font',
        'textBaseline',
        'textAlign',
        'clearRect',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'globalAlpha',
        'measureText',
        'fillText',
        'measureText',
        'fillText',
        'measureText',
        'fillText',
        'measureText',
        'fillText',
        'measureText',
        'fillText',
        'measureText',
        'fillText',
        'measureText',
        'fillText',
        'rotate',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'rotate',
        'globalAlpha',
      ],
    },
    visual2: {
      visualPosition: 10,
      hash: '9b349ba1d344b7221644251000ec8b73',
      IS: [
        'setTransform',
        'translate',
        'globalAlpha',
        'lineWidth',
        'strokeStyle',
        'font',
        'textBaseline',
        'textAlign',
        'clearRect',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'fillRect',
        'beginPath',
        'rect',
        'stroke',
        'fillStyle',
        'globalAlpha',
        'measureText',
        'fillText',
        'measureText',
        'fillText',
        'measureText',
        'fillText',
        'rotate',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'measureText',
        'fillText',
        'fillText',
        'rotate',
        'globalAlpha',
      ],
    },
  };
  const instore = {
    include: {
      visual1: {
        visualPosition: 1,
        hash: '1afc7272758a6cf51c95fa4e28829fc5',
        IS: [
          'setTransform',
          'translate',
          'globalAlpha',
          'lineWidth',
          'strokeStyle',
          'font',
          'textBaseline',
          'textAlign',
          'clearRect',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'globalAlpha',
          'measureText',
          'fillText',
          'rotate',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'rotate',
          'globalAlpha',
        ],
        visualType: '.chart-icon-corelation',
      },
      visual2: {
        visualPosition: 2,
        hash: 'a9ceaccd1d0d29bd4d3d3a7977d81f39',
        IS: [
          'setTransform',
          'translate',
          'globalAlpha',
          'font',
          'setTransform',
          'translate',
          'clearRect',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
        ],
        visualType: '.chart-icon-combo',
      },
      visual3: {
        visualPosition: 7,
        hash: '354e0b5545b66763a16dbd600e2df933',
        IS: [
          'setTransform',
          'translate',
          'translate',
          'globalAlpha',
          'font',
          'textBaseline',
          'textAlign',
          'clearRect',
          'beginPath',
          'moveTo',
          'arc',
          'moveTo',
          'arc',
          'closePath',
          'fillStyle',
          'fill',
          'fillStyle',
          'measureText',
          'fillText',
        ],
        visualType: '.chart-icon-pie',
      },
    },
    exclude: {
      visual1: {
        visualPosition: 1,
        hash: '61907e92aa1929689e009d071750a463',
        IS: [
          'setTransform',
          'translate',
          'globalAlpha',
          'lineWidth',
          'strokeStyle',
          'font',
          'textBaseline',
          'textAlign',
          'clearRect',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'globalAlpha',
          'measureText',
          'fillText',
          'measureText',
          'fillText',
          'measureText',
          'fillText',
          'measureText',
          'fillText',
          'rotate',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'rotate',
          'globalAlpha',
        ],
        visualType: '.chart-icon-corelation',
      },
      visual2: {
        visualPosition: 2,
        hash: '4c9950b157b998992fb3d427571c2ba1',
        IS: [
          'setTransform',
          'translate',
          'globalAlpha',
          'font',
          'setTransform',
          'translate',
          'clearRect',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
        ],
        visualType: '.chart-icon-combo',
      },
      visual3: {
        visualPosition: 7,
        // hash: '1860235190251a9025d054d2ce61e153',
        hash: 'fd924c159fb3add4e7300d429a52d933',
        // IS: ['setTransform', 'translate', 'translate', 'globalAlpha', 'font', 'textBaseline', 'textAlign', 'clearRect', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText'],
        IS: [
          'setTransform',
          'translate',
          'translate',
          'globalAlpha',
          'font',
          'textBaseline',
          'textAlign',
          'clearRect',
          'beginPath',
          'moveTo',
          'arc',
          'arc',
          'closePath',
          'fillStyle',
          'fill',
          'fillStyle',
          'measureText',
          'fillText',
          'beginPath',
          'moveTo',
          'arc',
          'arc',
          'closePath',
          'fillStyle',
          'fill',
          'fillStyle',
          'measureText',
          'beginPath',
          'moveTo',
          'arc',
          'arc',
          'closePath',
          'fillStyle',
          'fill',
          'fillStyle',
          'measureText',
          'fillText',
          'beginPath',
          'moveTo',
          'arc',
          'arc',
          'closePath',
          'fillStyle',
          'fill',
          'fillStyle',
          'measureText',
        ],
        visualType: '.chart-icon-pie',
      },
    },
    reset: {
      visual1: {
        visualPosition: 1,
        hash: '61907e92aa1929689e009d071750a463',
        IS: [
          'setTransform',
          'translate',
          'globalAlpha',
          'lineWidth',
          'strokeStyle',
          'font',
          'textBaseline',
          'textAlign',
          'clearRect',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'fillRect',
          'beginPath',
          'rect',
          'stroke',
          'fillStyle',
          'globalAlpha',
          'measureText',
          'fillText',
          'measureText',
          'fillText',
          'measureText',
          'fillText',
          'measureText',
          'fillText',
          'rotate',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'measureText',
          'fillText',
          'fillText',
          'rotate',
          'globalAlpha',
        ],
        visualType: '.chart-icon-corelation',
      },
      visual2: {
        visualPosition: 2,
        hash: 'b7dfad8637465421f7cd32caae48d9ed',
        IS: [
          'setTransform',
          'translate',
          'globalAlpha',
          'font',
          'setTransform',
          'translate',
          'clearRect',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
          'fillStyle',
          'beginPath',
          'rect',
          'fill',
        ],
        visualType: '.chart-icon-combo',
      },
      visual3: {
        visualPosition: 7,
        hash: 'fd924c159fb3add4e7300d429a52d933',
        IS: [
          'setTransform',
          'translate',
          'translate',
          'globalAlpha',
          'font',
          'textBaseline',
          'textAlign',
          'clearRect',
          'beginPath',
          'moveTo',
          'arc',
          'arc',
          'closePath',
          'fillStyle',
          'fill',
          'fillStyle',
          'measureText',
          'fillText',
          'beginPath',
          'moveTo',
          'arc',
          'arc',
          'closePath',
          'fillStyle',
          'fill',
          'fillStyle',
          'measureText',
          'beginPath',
          'moveTo',
          'arc',
          'arc',
          'closePath',
          'fillStyle',
          'fill',
          'fillStyle',
          'measureText',
          'fillText',
          'beginPath',
          'moveTo',
          'arc',
          'arc',
          'closePath',
          'fillStyle',
          'fill',
          'fillStyle',
          'measureText',
        ],
        visualType: '.chart-icon-pie',
      },
    },
  };
  before(() => {
    arctest.logins.silent();
  });

  it('Import Veliko App if not exists', () => {
    functions.navigate_to_visuals();
    cy.get(CSSselector.Visuals_all).click();

    functions.typeInSearchField(appName);
    cy.get('body').then(($dash) => {
      if (!$dash.text().includes(appName)) {
        imp_exp.import_artifacts('Arcengine', appFile);
      }
    });
  });

  it('Launch Veliko App and check Plan and Event Type filters in all the dashboards', () => {
    functions.navigate_to_visuals();
    cy.get(`${CSSselector.Visuals_all}`).click();
    cy.get(`${CSSselector.listview_Visualspage}`).click();
    cy.get(apps.locators.apps_list).click({ force: true });
    const appTitle = 'Veliko';

    functions.typeInSearchField(`"${appTitle}"`);
    cy.wait(2000);
    cy.get(`[data-test-id="${appTitle}"]`)
      .find(imp_exp.locators.grid_item)
      .click();
    cy.intercept('GET', '/arc/reports/report/*').as('loadApp');
    cy.wait('@loadApp')
      .its('response.statusCode')
      .should('eq', 200);
    cy.get(apps.locators.app_tabs).each(($el, index, $list) => {
      if (index === 0) {
        expect($el).have.class('active');
        cy.wrap($el).click();
        cy.get(apps.locators.tab_dropdown).each(($dash, i, array) => {
          expect($dash).have.class('arc-link');
          cy.wrap($dash)
            .should('contain', dashboardName[i])
            .click({ force: true });
          cy.get(apps.locators.dashboard_title).should('have.text', dashboardName[i]);
          cy.get(filter.locators.filter_title).should('contain', filterName);
        });
      } else {
        cy.wrap($list[index])
          .click()
          .should('have.class', 'active');
        cy.get('a').then(($dash) => {
          expect($dash).have.class('arc-link');
          cy.get(apps.locators.dashboard_title).should('have.text', dashboardName[index + 1]);
          cy.get(filter.locators.filter_title).should('contain', filterName);
        });
      }
    });
  });

  // to run test cases from here, we need to on the 'Launch App' page.
  it('Apply Plan and Event Type filter on VELIKO - Customer Cost Details Tab ', () => {
    cy.intercept('POST', '/arc/sqlrun/jsonselect_parallel_async/*').as('pageLoaded');
    for (let i = 0; i < 3; i++) {
      cy.get(apps.locators.first_tab)
        .click()
        .should('have.class', 'open');
      cy.get(apps.locators.tab_dropdown)
        .first()
        .click();
      cy.get(apps.locators.filter_dropdown.replace('index', '1')).click({ force: true });
      cy.get(apps.locators.filter_values.replace('index', '1'))
        .find('label[title="' + eventFilter[i] + '"] input')
        .check();
      const visuals = arctest.screen.builder.locators.visuals;
      const selectors = [
        visuals + ':nth-child(1)',
        visuals + ':nth-child(2)',
        visuals + ':nth-child(3)',
        visuals + ':nth-child(4)',
      ];
      arctest.screen.builder.verifyTableContents(selectors[0], [
        ['H', 'Ceccherini', '39 081-412222', 'm', 'Napoli', 'NEUTRAL CLV', '17'],
      ]);
      arctest.screen.builder.verifyTableContents(selectors[1], [['SMP-6', 'V-500', '2']]);
      arctest.screen.builder.verifyTableContents(selectors[2], [['€10.00', '€0.00', '€14.10']]);
      arctest.screen.builder.verifyTableContents(selectors[3], [['816', '3,888', '778']]);
      cy.get(filter.locators.canvas_svg_yaxis.replace('index', '6'))
        .should('contain', 'QOS')
        .should('contain', 'ONLINE');
      cy.get(visuals + ':nth-child(5)')
        .should('not.contain', 'IN-STORE')
        .should('not.contain', 'QOS')
        .should('not.contain', 'ONLINE');
      filter.verifyCurrentParametersForTelco('event', eventFilter[i], false);

      cy.get(apps.locators.first_tab)
        .click()
        .should('have.class', 'open');
      cy.get(apps.locators.second_dash_of_first_tab).click();
      cy.wait('@pageLoaded')
        .its('response.statusCode')
        .should('be.eq', 200);
      filter.verifyFilterContent(arctest.screen.builder.locators.filter_widgets + ':nth-child(1)', [
        eventFilter[i],
      ]);
      filter.verifyCurrentParametersForTelco('event', eventFilter[i], false);
      if (i === 0) {
        visual.verifyVisualHash(
          instore.include.visual1.visualPosition,
          instore.include.visual1.hash,
          instore.include.visual1.IS,
          instore.include.visual1.visualType
        );
        visual.verifyVisualHash(
          instore.include.visual2.visualPosition,
          instore.include.visual2.hash,
          instore.include.visual2.IS,
          instore.include.visual2.visualType
        );
        visual.verifyVisualHash(
          instore.include.visual3.visualPosition,
          instore.include.visual3.hash,
          instore.include.visual3.IS,
          instore.include.visual3.visualType
        );
        filter.verifyTelcoKPIs(3, 4, ['26493', '0.00', '€0.50', '€0.03']);
      } else if (i === 1) {
        visual.verifyVisualHash(
          instore.include.visual1.visualPosition,
          instore.include.visual1.hash,
          instore.include.visual1.IS,
          instore.include.visual1.visualType
        );
        visual.verifyVisualHash(
          instore.include.visual2.visualPosition,
          instore.include.visual2.hash,
          instore.include.visual2.IS,
          instore.include.visual2.visualType
        );
        visual.verifyVisualHash(
          instore.include.visual3.visualPosition,
          instore.include.visual3.hash,
          instore.include.visual3.IS,
          instore.include.visual3.visualType
        );
        filter.verifyTelcoKPIs(3, 4, ['319315', '0.02', '€0.02', '€0.00']);
      } else {
        visual.verifyVisualHash(
          instore.include.visual1.visualPosition,
          instore.include.visual1.hash,
          instore.include.visual1.IS,
          instore.include.visual1.visualType
        );
        visual.verifyVisualHash(
          instore.include.visual2.visualPosition,
          instore.include.visual2.hash,
          instore.include.visual2.IS,
          instore.include.visual2.visualType
        );
        visual.verifyVisualHash(
          instore.include.visual3.visualPosition,
          instore.include.visual3.hash,
          instore.include.visual3.IS,
          instore.include.visual3.visualType
        );
        filter.verifyTelcoKPIs(3, 4, ['158019', '0.01', '€3.00', '€0.21']);
      }

      cy.get(apps.locators.app_tabs + ':nth-child(2)')
        .click()
        .should('have.class', 'active');
      cy.wait('@pageLoaded')
        .its('response.statusCode')
        .should('be.eq', 200);
      filter.verifyFilterContent(arctest.screen.builder.locators.filter_widgets + ':nth-child(1)', [
        eventFilter[i],
      ]);
      filter.verifyCurrentParametersForTelco('event', eventFilter[i], false);
      filter.verifyTelcoKPIs(1, 3, ['5,791,439', '539,215', '10,747']);
      filter.verifyTelcoKPIs(7, 4, ['1,001,455', '€19.43', '80,050', '3.23%']);
      cy.get(filter.locators.canvas_svg_xaxis.replace('index', '4'))
        .should('not.contain', 'IN-STORE')
        .should('not.contain', 'QOS')
        .should('not.contain', 'ONLINE');
      cy.get(filter.locators.canvas_svg_xaxis.replace('index', '5'))
        .should('not.contain', 'IN-STORE')
        .should('not.contain', 'QOS')
        .should('not.contain', 'ONLINE');
      cy.get(filter.locators.canvas_svg_xaxis.replace('index', '6'))
        .should('not.contain', 'IN-STORE')
        .should('not.contain', 'QOS')
        .should('not.contain', 'ONLINE');
      filter.verifyCurrentParametersForTelco('event', eventFilter[i], false);

      cy.get(apps.locators.app_tabs + ':nth-child(3)')
        .click()
        .should('have.class', 'active');
      cy.wait('@pageLoaded')
        .its('response.statusCode')
        .should('be.eq', 200);
      filter.verifyFilterContent(arctest.screen.builder.locators.filter_widgets + ':nth-child(1)', [
        eventFilter[i],
      ]);
      filter.verifyCurrentParametersForTelco('event', eventFilter[i], false);
      cy.get(filter.locators.canvas_svg_xaxis.replace('index', '8'))
        .should('not.contain', 'IN-STORE')
        .should('not.contain', 'QOS')
        .should('not.contain', 'ONLINE');
      cy.get(filter.locators.canvas_svg_xaxis.replace('index', '12'))
        .should('not.contain', 'IN-STORE')
        .should('not.contain', 'QOS')
        .should('not.contain', 'ONLINE');
      if (i === 0) {
        filter.verifyTelcoKPIs(1, 7, [
          '€19.00',
          '421,150',
          '13,020',
          '€27.50',
          '13,223',
          '4,802',
          '3,578',
        ]);
        filter.verifyTelcoKPIs(11, 1, ['410']);
        cy.get(filter.locators.visual_li + ':nth-child(13) svg').should('contain', 'IN-STORE');
        cy.wait(2000);
        visual.verifyVisualHash(
          churnVisual.visual1.visualPosition,
          churnVisual.visual1.hash,
          churnVisual.visual1.IS,
          churnVisual.visualType
        );
        cy.get(filter.locators.visual_li + ':nth-child(10)').scrollIntoView();
        visual.verifyVisualHash(
          churnVisual.visual2.visualPosition,
          churnVisual.visual2.hash,
          churnVisual.visual2.IS,
          churnVisual.visualType
        );
      } else if (i === 1) {
        filter.verifyTelcoKPIs(1, 7, [
          '€0.10',
          '421,150',
          '14,132',
          '€27.60',
          '159,939',
          '58,762',
          '43,328',
        ]);
        filter.verifyTelcoKPIs(11, 1, ['449']);
        cy.get(filter.locators.visual_li + ':nth-child(13) svg').should(
          'contain',
          'ONLINE: BILL PAY'
        );
        cy.wait(2000);
        visual.verifyVisualHash(
          churnVisual.visual1.visualPosition,
          churnVisual.visual1.hash,
          churnVisual.visual1.IS,
          churnVisual.visualType
        );
        cy.get(filter.locators.visual_li + ':nth-child(10)').scrollIntoView();
        visual.verifyVisualHash(
          churnVisual.visual2.visualPosition,
          churnVisual.visual2.hash,
          churnVisual.visual2.IS,
          churnVisual.visualType
        );
      } else {
        filter.verifyTelcoKPIs(1, 7, [
          '€19.00',
          '421,150',
          '13,227',
          '€27.60',
          '79,254',
          '29,063',
          '21,409',
        ]);
        filter.verifyTelcoKPIs(11, 1, ['407']);
        cy.get(filter.locators.visual_li + ':nth-child(13) svg').should(
          'contain',
          'QOS: CALL QUALITY'
        );
        cy.wait(2000);
        visual.verifyVisualHash(
          churnVisual.visual1.visualPosition,
          churnVisual.visual1.hash,
          churnVisual.visual1.IS,
          churnVisual.visualType
        );
        cy.get(filter.locators.visual_li + ':nth-child(10)').scrollIntoView();
        visual.verifyVisualHash(
          churnVisual.visual2.visualPosition,
          churnVisual.visual2.hash,
          churnVisual.visual2.IS,
          churnVisual.visualType
        );
      }
      cy.get(CSSselector.dashboard.reset_button).click({ force: true });
    }
  });

  it('Verify Exclude, Forward, Backward and Reset filter features of Veliko App ', () => {
    cy.intercept('POST', '/arc/sqlrun/jsonselect_parallel_async/*').as('pageLoaded');
    for (let i = 0; i <= 3; i++) {
      cy.get(apps.locators.first_tab)
        .click()
        .should('have.class', 'open');
      cy.get(apps.locators.tab_dropdown)
        .first()
        .click();
      switch (i) {
        //  Apply IN-STORE: BILLING ISSUE filter value of Event Filter and verify exclude features on all the veliko dashboards
        case 0:
          cy.get(apps.locators.filter_dropdown.replace('index', '1')).click({ force: true });
          cy.get(apps.locators.filter_values.replace('index', '1'))
            .find('label[title="' + eventFilter[0] + '"] input')
            .check();
          cy.get(filter.locators.exclude_filter.replace('index', '1')).check({ force: true });
          filter.verifyCurrentParametersForTelco('event', eventFilter[0], true);

          cy.get(apps.locators.first_tab)
            .click()
            .should('have.class', 'open');
          cy.get(apps.locators.second_dash_of_first_tab).click();
          cy.wait('@pageLoaded')
            .its('response.statusCode')
            .should('be.eq', 200);
          filter.verifyCurrentParametersForTelco('event', eventFilter[0], true);
          visual.verifyVisualHash(
            instore.exclude.visual1.visualPosition,
            instore.exclude.visual1.hash,
            instore.exclude.visual1.IS,
            instore.exclude.visual1.visualType
          );
          visual.verifyVisualHash(
            instore.exclude.visual2.visualPosition,
            instore.exclude.visual2.hash,
            instore.exclude.visual2.IS,
            instore.exclude.visual2.visualType
          );
          visual.verifyVisualHash(
            instore.exclude.visual3.visualPosition,
            instore.exclude.visual3.hash,
            instore.exclude.visual3.IS,
            instore.exclude.visual3.visualType
          );
          filter.verifyTelcoKPIs(3, 4, ['1022081', '0.08', '€12.87', '€0.89']);

          cy.get(apps.locators.app_tabs + ':nth-child(2)')
            .click()
            .should('have.class', 'active');
          cy.wait('@pageLoaded')
            .its('response.statusCode')
            .should('be.eq', 200);
          filter.verifyCurrentParametersForTelco('event', eventFilter[0], true);

          cy.get(apps.locators.app_tabs + ':nth-child(3)')
            .click()
            .should('have.class', 'active');
          cy.wait('@pageLoaded')
            .its('response.statusCode')
            .should('be.eq', 200);
          filter.verifyCurrentParametersForTelco('event', eventFilter[0], true);
          filter.verifyTelcoKPIs(1, 7, [
            '€12.50',
            '421,150',
            '14,132',
            '€27.60',
            '507,912',
            '186,329',
            '137,359',
          ]);
          filter.verifyTelcoKPIs(11, 1, ['449']);
          cy.get(filter.locators.visual_li + ':nth-child(13) svg').should(
            'not.contain',
            'IN-STORE: BILLING'
          );
          cy.wait(2000);
          visual.verifyVisualHash(
            churnVisual.visual1.visualPosition,
            churnVisual.visual1.hash,
            churnVisual.visual1.IS,
            churnVisual.visualType
          );
          cy.get(filter.locators.visual_li + ':nth-child(10)').scrollIntoView();
          visual.verifyVisualHash(
            churnVisual.visual2.visualPosition,
            churnVisual.visual2.hash,
            churnVisual.visual2.IS,
            churnVisual.visualType
          );
          break;
        case 1:
          //  Apply IN-STORE: BILLING ISSUE filter value of Event Filter and verify Backward feature on all the veliko dashboards
          cy.get(CSSselector.dashboard.back_button).click({ force: true });
          filter.verifyCurrentParametersForTelco('event', 'No parameters');

          cy.get(apps.locators.first_tab)
            .click()
            .should('have.class', 'open');
          cy.get(apps.locators.second_dash_of_first_tab).click();
          cy.wait('@pageLoaded')
            .its('response.statusCode')
            .should('be.eq', 200);
          filter.verifyCurrentParametersForTelco('event', 'No parameters');
          visual.verifyVisualHash(
            instore.reset.visual1.visualPosition,
            instore.reset.visual1.hash,
            instore.reset.visual1.IS,
            instore.reset.visual1.visualType
          );
          visual.verifyVisualHash(
            instore.reset.visual2.visualPosition,
            instore.reset.visual2.hash,
            instore.reset.visual2.IS,
            instore.reset.visual2.visualType
          );
          visual.verifyVisualHash(
            instore.reset.visual3.visualPosition,
            instore.reset.visual3.hash,
            instore.reset.visual3.IS,
            instore.reset.visual3.visualType
          );
          filter.verifyTelcoKPIs(3, 4, ['1048574', '0.08', '€13.37', '€0.92']);

          cy.get(apps.locators.app_tabs + ':nth-child(2)')
            .click()
            .should('have.class', 'active');
          cy.wait('@pageLoaded')
            .its('response.statusCode')
            .should('be.eq', 200);
          filter.verifyCurrentParametersForTelco('event', 'No parameters');

          cy.get(apps.locators.app_tabs + ':nth-child(3)')
            .click()
            .should('have.class', 'active');
          cy.wait('@pageLoaded')
            .its('response.statusCode')
            .should('be.eq', 200);
          filter.verifyCurrentParametersForTelco('event', 'No parameters');
          filter.verifyTelcoKPIs(1, 7, [
            '€12.70',
            '421,150',
            '14,132',
            '€27.60',
            '521,135',
            '191,131',
            '140,937',
          ]);
          filter.verifyTelcoKPIs(11, 1, ['449']);
          cy.get(filter.locators.visual_li + ':nth-child(13) svg')
            .should('contain', 'IN-STORE: BILLING')
            .should('contain', 'QOS');
          cy.wait(2000);
          visual.verifyVisualHash(
            churnVisual.visual1.visualPosition,
            churnVisual.visual1.hash,
            churnVisual.visual1.IS,
            churnVisual.visualType
          );
          cy.get(filter.locators.visual_li + ':nth-child(10)').scrollIntoView();
          visual.verifyVisualHash(
            churnVisual.visual2.visualPosition,
            churnVisual.visual2.hash,
            churnVisual.visual2.IS,
            churnVisual.visualType
          );
          break;
        case 2:
          //  Apply IN-STORE: BILLING ISSUE filter value of Event Filter and verify Forward feature on all the veliko dashboards
          cy.get(apps.locators.filter_dropdown.replace('index', '1')).click({ force: true });
          cy.get(apps.locators.filter_values.replace('index', '1'))
            .find('label[title="' + eventFilter[0] + '"] input')
            .check();
          cy.get(filter.locators.exclude_filter.replace('index', '1')).check({ force: true });
          cy.get(CSSselector.dashboard.back_button).click({ force: true });
          cy.get(CSSselector.dashboard.forward_button).click({ force: true });
          filter.verifyCurrentParametersForTelco('event', eventFilter[0], true);

          cy.get(apps.locators.first_tab)
            .click()
            .should('have.class', 'open');
          cy.get(apps.locators.second_dash_of_first_tab).click();
          cy.wait('@pageLoaded')
            .its('response.statusCode')
            .should('be.eq', 200);
          filter.verifyCurrentParametersForTelco('event', eventFilter[0], true);
          visual.verifyVisualHash(
            instore.exclude.visual1.visualPosition,
            instore.exclude.visual1.hash,
            instore.exclude.visual1.IS,
            instore.exclude.visual1.visualType
          );
          visual.verifyVisualHash(
            instore.exclude.visual2.visualPosition,
            instore.exclude.visual2.hash,
            instore.exclude.visual2.IS,
            instore.exclude.visual2.visualType
          );
          visual.verifyVisualHash(
            instore.exclude.visual3.visualPosition,
            instore.exclude.visual3.hash,
            instore.exclude.visual3.IS,
            instore.exclude.visual3.visualType
          );
          filter.verifyTelcoKPIs(3, 4, ['1022081', '0.08', '€12.87', '€0.89']);

          cy.get(apps.locators.app_tabs + ':nth-child(2)')
            .click()
            .should('have.class', 'active');
          cy.wait('@pageLoaded')
            .its('response.statusCode')
            .should('be.eq', 200);
          filter.verifyCurrentParametersForTelco('event', eventFilter[0], true);

          cy.get(apps.locators.app_tabs + ':nth-child(3)')
            .click()
            .should('have.class', 'active');
          cy.wait('@pageLoaded')
            .its('response.statusCode')
            .should('be.eq', 200);
          filter.verifyCurrentParametersForTelco('event', eventFilter[0], true);
          filter.verifyTelcoKPIs(1, 7, [
            '€12.50',
            '421,150',
            '14,132',
            '€27.60',
            '507,912',
            '186,329',
            '137,359',
          ]);
          filter.verifyTelcoKPIs(11, 1, ['449']);
          cy.get(filter.locators.visual_li + ':nth-child(13) svg').should(
            'not.contain',
            'IN-STORE: BILLING'
          );
          cy.wait(2000);
          visual.verifyVisualHash(
            churnVisual.visual1.visualPosition,
            churnVisual.visual1.hash,
            churnVisual.visual1.IS,
            churnVisual.visualType
          );
          cy.get(filter.locators.visual_li + ':nth-child(10)').scrollIntoView();
          visual.verifyVisualHash(
            churnVisual.visual2.visualPosition,
            churnVisual.visual2.hash,
            churnVisual.visual2.IS,
            churnVisual.visualType
          );
          break;
        case 3:
          //  Apply IN-STORE: BILLING ISSUE filter value of Event Filter and verify Reset feature on all the veliko dashboards
          cy.get(CSSselector.dashboard.reset_button).click({ force: true });
          filter.verifyCurrentParametersForTelco('event', 'No parameters');

          cy.get(apps.locators.first_tab)
            .click()
            .should('have.class', 'open');
          cy.get(apps.locators.second_dash_of_first_tab).click();
          cy.wait('@pageLoaded')
            .its('response.statusCode')
            .should('be.eq', 200);
          filter.verifyCurrentParametersForTelco('event', 'No parameters');
          visual.verifyVisualHash(
            instore.reset.visual1.visualPosition,
            instore.reset.visual1.hash,
            instore.reset.visual1.IS,
            instore.reset.visual1.visualType
          );
          visual.verifyVisualHash(
            instore.reset.visual2.visualPosition,
            instore.reset.visual2.hash,
            instore.reset.visual2.IS,
            instore.reset.visual2.visualType
          );
          visual.verifyVisualHash(
            instore.reset.visual3.visualPosition,
            instore.reset.visual3.hash,
            instore.reset.visual3.IS,
            instore.reset.visual3.visualType
          );
          filter.verifyTelcoKPIs(3, 4, ['1048574', '0.08', '€13.37', '€0.92']);

          cy.get(apps.locators.app_tabs + ':nth-child(2)')
            .click()
            .should('have.class', 'active');
          cy.wait('@pageLoaded')
            .its('response.statusCode')
            .should('be.eq', 200);
          filter.verifyCurrentParametersForTelco('event', 'No parameters');

          cy.get(apps.locators.app_tabs + ':nth-child(3)')
            .click()
            .should('have.class', 'active');
          cy.wait('@pageLoaded')
            .its('response.statusCode')
            .should('be.eq', 200);
          filter.verifyCurrentParametersForTelco('event', 'No parameters');
          filter.verifyTelcoKPIs(1, 7, [
            '€12.70',
            '421,150',
            '14,132',
            '€27.60',
            '521,135',
            '191,131',
            '140,937',
          ]);
          filter.verifyTelcoKPIs(11, 1, ['449']);
          cy.get(filter.locators.visual_li + ':nth-child(13) svg')
            .should('contain', 'IN-STORE: BILLING')
            .should('contain', 'QOS');
          cy.wait(2000);
          visual.verifyVisualHash(
            churnVisual.visual1.visualPosition,
            churnVisual.visual1.hash,
            churnVisual.visual1.IS,
            churnVisual.visualType
          );
          cy.get(filter.locators.visual_li + ':nth-child(10)').scrollIntoView();
          visual.verifyVisualHash(
            churnVisual.visual2.visualPosition,
            churnVisual.visual2.hash,
            churnVisual.visual2.IS,
            churnVisual.visualType
          );
          break;
      }
    }
  });
});
