import { logins } from 'lib/arctest';
import * as dashboard from 'lib/dashboard/dashboard_functions';
import * as filter from 'lib/filter';
import * as functions from 'lib/functions';
import * as imp_exp from 'lib/import_export';
import * as visual from 'lib/visual';
import { CSSselector } from 'locators/common/CSSselector';

describe('Default Values', () => {
  const dashboardName = 'Clone of VELIKO - Fiscal Year - Customer Service Quality / Cost Dashboard';
  const dashboardFile =
    'Clone of VELIKO - Fiscal Year - Customer Service Quality  Cost Dashboard (1).json';

  // prettier-ignore
  const instore = {
    include: {
      visual1: {
        visualPosition: 1,
        hash: '1afc7272758a6cf51c95fa4e28829fc5',
        IS: ['setTransform', 'translate', 'globalAlpha', 'lineWidth', 'strokeStyle', 'font', 'textBaseline', 'textAlign', 'clearRect', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'globalAlpha', 'measureText', 'fillText', 'rotate', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'rotate', 'globalAlpha'],
        visualType: '.chart-icon-corelation'
      },
      visual2: {
        visualPosition: 2,
        hash: '265acb8d55bbee7112e2a1bf0b233d9d',
        hash2: 'a9ceaccd1d0d29bd4d3d3a7977d81f39',
        IS: ['setTransform', 'translate', 'globalAlpha', 'font', 'setTransform', 'translate', 'clearRect', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill'],
        IS2: ['setTransform', 'translate', 'globalAlpha', 'font', 'setTransform', 'translate', 'clearRect', 'fillStyle', 'beginPath', 'rect', 'fill'],
        visualType: '.chart-icon-combo'
      },
      visual3: {
        visualPosition: 7,
        hash: '354e0b5545b66763a16dbd600e2df933',
        IS: ['setTransform', 'translate', 'translate', 'globalAlpha', 'font', 'textBaseline', 'textAlign', 'clearRect', 'beginPath', 'moveTo', 'arc', 'moveTo', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText'],
        visualType: '.chart-icon-pie'
      }
    },
    exclude: {
      visual1: {
        visualPosition: 1,
        hash: '61907e92aa1929689e009d071750a463',
        IS: ['setTransform', 'translate', 'globalAlpha', 'lineWidth', 'strokeStyle', 'font', 'textBaseline', 'textAlign', 'clearRect', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'globalAlpha', 'measureText', 'fillText', 'measureText', 'fillText', 'measureText', 'fillText', 'measureText', 'fillText', 'rotate', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'rotate', 'globalAlpha'],
        visualType: '.chart-icon-corelation'
      },
      visual2: {
        visualPosition: 2,
        hash: '437cbc83a2fdb9cd249a1a7851592f3d',
        hash2: '4c9950b157b998992fb3d427571c2ba1',
        IS: ['setTransform', 'translate', 'globalAlpha', 'font', 'setTransform', 'translate', 'clearRect', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill'],
        IS2: ['setTransform', 'translate', 'globalAlpha', 'font', 'setTransform', 'translate', 'clearRect', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill'],
        visualType: '.chart-icon-combo'
      },
      visual3: {
        visualPosition: 7,
        hash: '8cf395424cee98f011d49e2329352609',
        hash2: '1860235190251a9025d054d2ce61e153',
        // hash2 : 'fd924c159fb3add4e7300d429a52d933',
        IS: ['setTransform', 'translate', 'translate', 'globalAlpha', 'font', 'textBaseline', 'textAlign', 'clearRect', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText'],
        IS2: ['setTransform', 'translate', 'translate', 'globalAlpha', 'font', 'textBaseline', 'textAlign', 'clearRect', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText'],
        // IS2 : ['setTransform', 'translate', 'translate', 'globalAlpha', 'font', 'textBaseline', 'textAlign', 'clearRect', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText'],
        visualType: '.chart-icon-pie'
      }
    },
    reset: {
      visual1: {
        visualPosition: 1,
        hash: '61907e92aa1929689e009d071750a463',
        IS: ['setTransform', 'translate', 'globalAlpha', 'lineWidth', 'strokeStyle', 'font', 'textBaseline', 'textAlign', 'clearRect', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'globalAlpha', 'measureText', 'fillText', 'measureText', 'fillText', 'measureText', 'fillText', 'measureText', 'fillText', 'rotate', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'rotate', 'globalAlpha'],
        visualType: '.chart-icon-corelation'
      },
      visual2: {
        visualPosition: 2,
        hash: 'b7dfad8637465421f7cd32caae48d9ed',
        IS: ['setTransform', 'translate', 'globalAlpha', 'font', 'setTransform', 'translate', 'clearRect', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill'],
        visualType: '.chart-icon-combo'
      },
      visual3: {
        visualPosition: 7,
        hash: 'fd924c159fb3add4e7300d429a52d933',
        IS: ['setTransform', 'translate', 'translate', 'globalAlpha', 'font', 'textBaseline', 'textAlign', 'clearRect', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText'],
        visualType: '.chart-icon-pie'
      }
    }

  };
  // prettier-ignore
  const online = {
    include: {
      visual1: {
        visualPosition: 1,
        hash: '1afc7272758a6cf51c95fa4e28829fc5',
        IS: ['setTransform', 'translate', 'globalAlpha', 'lineWidth', 'strokeStyle', 'font', 'textBaseline', 'textAlign', 'clearRect', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'globalAlpha', 'measureText', 'fillText', 'rotate', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'rotate', 'globalAlpha'],
        visualType: '.chart-icon-corelation'
      },
      visual2: {
        visualPosition: 2,
        hash: '228a69c342f079d2506538d2ab162dde',
        hash2: 'a9ceaccd1d0d29bd4d3d3a7977d81f39',
        IS: ['setTransform', 'translate', 'globalAlpha', 'font', 'setTransform', 'translate', 'clearRect', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill'],
        IS2: ['setTransform', 'translate', 'globalAlpha', 'font', 'setTransform', 'translate', 'clearRect', 'fillStyle', 'beginPath', 'rect', 'fill'],
        visualType: '.chart-icon-combo'
      },
      visual3: {
        visualPosition: 7,
        hash: '354e0b5545b66763a16dbd600e2df933',
        IS: ['setTransform', 'translate', 'translate', 'globalAlpha', 'font', 'textBaseline', 'textAlign', 'clearRect', 'beginPath', 'moveTo', 'arc', 'moveTo', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText'],
        visualType: '.chart-icon-pie'
      }
    },
    exclude: {
      visual1: {
        visualPosition: 1,
        hash: '61907e92aa1929689e009d071750a463',
        IS: ['setTransform', 'translate', 'globalAlpha', 'lineWidth', 'strokeStyle', 'font', 'textBaseline', 'textAlign', 'clearRect', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'globalAlpha', 'measureText', 'fillText', 'measureText', 'fillText', 'measureText', 'fillText', 'measureText', 'fillText', 'rotate', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'rotate', 'globalAlpha'],
        visualType: '.chart-icon-corelation'
      },
      visual2: {
        visualPosition: 2,
        hash: 'bb9e0433c44fc492d89f77498994df6b',
        hash2: '4c9950b157b998992fb3d427571c2ba1',
        IS: ['setTransform', 'translate', 'globalAlpha', 'font', 'setTransform', 'translate', 'clearRect', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill'],
        IS2: ['setTransform', 'translate', 'globalAlpha', 'font', 'setTransform', 'translate', 'clearRect', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill'],
        visualType: '.chart-icon-combo'
      },
      visual3: {
        visualPosition: 7,
        hash: '7976f7cb6f11dd7dc5bf04c1eb964c58',
        // hash : '8cf395424cee98f011d49e2329352609',
        // hash2 : 'fd924c159fb3add4e7300d429a52d933',
        hash2: '1860235190251a9025d054d2ce61e153',
        IS: ['setTransform', 'translate', 'translate', 'globalAlpha', 'font', 'textBaseline', 'textAlign', 'clearRect', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText'],
        // IS : ['setTransform', 'translate', 'translate', 'globalAlpha', 'font', 'textBaseline', 'textAlign', 'clearRect', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText'],
        // IS2 : ['setTransform', 'translate', 'translate', 'globalAlpha', 'font', 'textBaseline', 'textAlign', 'clearRect', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText'],
        IS2: ['setTransform', 'translate', 'translate', 'globalAlpha', 'font', 'textBaseline', 'textAlign', 'clearRect', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText'],
        visualType: '.chart-icon-pie'
      }
    },
    reset: {
      visual1: {
        visualPosition: 1,
        hash: '61907e92aa1929689e009d071750a463',
        IS: ['setTransform', 'translate', 'globalAlpha', 'lineWidth', 'strokeStyle', 'font', 'textBaseline', 'textAlign', 'clearRect', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'globalAlpha', 'measureText', 'fillText', 'measureText', 'fillText', 'measureText', 'fillText', 'measureText', 'fillText', 'rotate', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'rotate', 'globalAlpha'],
        visualType: '.chart-icon-corelation'
      },
      visual2: {
        visualPosition: 2,
        hash: 'b7dfad8637465421f7cd32caae48d9ed',
        IS: ['setTransform', 'translate', 'globalAlpha', 'font', 'setTransform', 'translate', 'clearRect', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill'],
        visualType: '.chart-icon-combo'
      },
      visual3: {
        visualPosition: 7,
        hash: 'fd924c159fb3add4e7300d429a52d933',
        IS: ['setTransform', 'translate', 'translate', 'globalAlpha', 'font', 'textBaseline', 'textAlign', 'clearRect', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText'],
        visualType: '.chart-icon-pie'
      }
    }
  };
  // prettier-ignore
  const qos = {
    include: {
      visual1: {
        visualPosition: 1,
        hash: '61907e92aa1929689e009d071750a463',
        hash2: '1afc7272758a6cf51c95fa4e28829fc5',
        IS: ['setTransform', 'translate', 'globalAlpha', 'lineWidth', 'strokeStyle', 'font', 'textBaseline', 'textAlign', 'clearRect', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'globalAlpha', 'measureText', 'fillText', 'measureText', 'fillText', 'measureText', 'fillText', 'measureText', 'fillText', 'rotate', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'rotate', 'globalAlpha'],
        IS2: ['setTransform', 'translate', 'globalAlpha', 'lineWidth', 'strokeStyle', 'font', 'textBaseline', 'textAlign', 'clearRect', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'globalAlpha', 'measureText', 'fillText', 'rotate', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'rotate', 'globalAlpha'],
        visualType: '.chart-icon-corelation'
      },
      visual2: {
        visualPosition: 2,
        hash: '4b061d87b4a269f6fbe17697a86fcb9a',
        hash2: 'a9ceaccd1d0d29bd4d3d3a7977d81f39',
        IS: ['setTransform', 'translate', 'globalAlpha', 'font', 'setTransform', 'translate', 'clearRect', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill'],
        IS2: ['setTransform', 'translate', 'globalAlpha', 'font', 'setTransform', 'translate', 'clearRect', 'fillStyle', 'beginPath', 'rect', 'fill'],
        visualType: '.chart-icon-combo'
      },
      visual3: {
        visualPosition: 7,
        hash: '354e0b5545b66763a16dbd600e2df933',
        IS: ['setTransform', 'translate', 'translate', 'globalAlpha', 'font', 'textBaseline', 'textAlign', 'clearRect', 'beginPath', 'moveTo', 'arc', 'moveTo', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText'],
        visualType: '.chart-icon-pie'
      }
    },
    exclude: {
      visual1: {
        visualPosition: 1,
        hash: '1afc7272758a6cf51c95fa4e28829fc5',
        hash2: 'd9564e186d361cfe48e2a2cb811867ff',
        // IS : ['setTransform','translate','globalAlpha','lineWidth','strokeStyle','font','textBaseline','textAlign','clearRect','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','fillRect','beginPath','rect','stroke','fillStyle','globalAlpha','measureText','fillText','measureText','fillText','measureText','fillText','measureText','fillText','rotate','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','measureText','fillText','fillText','rotate','globalAlpha'],
        IS: ['setTransform', 'translate', 'globalAlpha', 'lineWidth', 'strokeStyle', 'font', 'textBaseline', 'textAlign', 'clearRect', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'globalAlpha', 'measureText', 'fillText', 'rotate', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'rotate', 'globalAlpha'],
        IS2: ['setTransform', 'translate', 'globalAlpha', 'lineWidth', 'strokeStyle', 'font', 'textBaseline', 'textAlign', 'clearRect', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'globalAlpha', 'measureText', 'fillText', 'measureText', 'fillText', 'measureText', 'fillText', 'rotate', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'rotate', 'globalAlpha'],
        visualType: '.chart-icon-corelation'
      },
      visual2: {
        visualPosition: 2,
        hash: '6aa5ffa6ecccb5a6f67493b0a5d58dee',
        hash2: '4c9950b157b998992fb3d427571c2ba1',
        IS: ['setTransform', 'translate', 'globalAlpha', 'font', 'setTransform', 'translate', 'clearRect', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill'],
        IS2: ['setTransform', 'translate', 'globalAlpha', 'font', 'setTransform', 'translate', 'clearRect', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill'],
        visualType: '.chart-icon-combo'
      },
      visual3: {
        visualPosition: 7,
        hash: '8cf395424cee98f011d49e2329352609',
        // hash2 : '8e6539485b1ac3aec7038fb2860341cd',
        hash2: 'bd6158d1889825fda2df4080489676ea',
        IS: ['setTransform', 'translate', 'translate', 'globalAlpha', 'font', 'textBaseline', 'textAlign', 'clearRect', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText'],
        // IS2 : ['setTransform', 'translate', 'translate', 'globalAlpha', 'font', 'textBaseline', 'textAlign', 'clearRect', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText'],
        IS2: ['setTransform', 'translate', 'translate', 'globalAlpha', 'font', 'textBaseline', 'textAlign', 'clearRect', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText'],
        visualType: '.chart-icon-pie'
      }
    },
    reset: {
      visual1: {
        visualPosition: 1,
        hash: '61907e92aa1929689e009d071750a463',
        IS: ['setTransform', 'translate', 'globalAlpha', 'lineWidth', 'strokeStyle', 'font', 'textBaseline', 'textAlign', 'clearRect', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'fillRect', 'beginPath', 'rect', 'stroke', 'fillStyle', 'globalAlpha', 'measureText', 'fillText', 'measureText', 'fillText', 'measureText', 'fillText', 'measureText', 'fillText', 'rotate', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'measureText', 'fillText', 'fillText', 'rotate', 'globalAlpha'],
        visualType: '.chart-icon-corelation'
      },
      visual2: {
        visualPosition: 2,
        hash: 'b7dfad8637465421f7cd32caae48d9ed',
        IS: ['setTransform', 'translate', 'globalAlpha', 'font', 'setTransform', 'translate', 'clearRect', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill', 'fillStyle', 'beginPath', 'rect', 'fill'],
        visualType: '.chart-icon-combo'
      },
      visual3: {
        visualPosition: 7,
        hash: 'fd924c159fb3add4e7300d429a52d933',
        IS: ['setTransform', 'translate', 'translate', 'globalAlpha', 'font', 'textBaseline', 'textAlign', 'clearRect', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText', 'fillText', 'beginPath', 'moveTo', 'arc', 'arc', 'closePath', 'fillStyle', 'fill', 'fillStyle', 'measureText'],
        visualType: '.chart-icon-pie'
      }
    },

  };

  before(() => {
    logins.silent();
  });

  it('Check that Send parameters with dataset scope is checked', () => {
    // dashboard.deleteMultipleDashboard(dashboardName);
    functions.navigate_to_visuals();
    cy.get(CSSselector.Visuals_all).click();

    functions.typeInSearchField(dashboardName);
    cy.get('body').then(($dash) => {
      if (!$dash.text().includes(dashboardName)) {
        imp_exp.import_artifacts(
          'Arcengine',
          'Clone of VELIKO - Fiscal Year - Customer Service Quality _ Cost Dashboard (1).json'
        );
      }
      dashboard.openDashboardforEdit(dashboardName);
      filter.verifySendParameterScopeofAllFilters();
      cy.reload();
    });
  });

  // prettier-ignore
  it('Check IN-STORE filter from Event Tye Filter of Telco Dashboard and verify current parameters with exclude feature', () => {
    cy.intercept('GET', '/arc/workspace/workspace').as('workspaceLoaded');
    cy.get(CSSselector.view_mode).click();
    // removed in https://bitbucket.org/arcadiadata/arcviz/commits/cbf059d5a1d01a35ec50c875144f14666f940235
    // cy.wait('@workspaceLoaded');
    functions.waitForVisualsLoaded();

    // applying IN-STORE filter from Event Type Filter
    filter.applyFilterToTelcoDashboard(['IN-STORE']);
    cy.wait(5000);
    visual.verifyVisualHash(
      instore.include.visual1.visualPosition,
      instore.include.visual1.hash,
      instore.include.visual1.IS,
      instore.include.visual1.visualType
    );
    visual.verifyVisualHash(
      instore.include.visual2.visualPosition,
      instore.include.visual2.hash,
      instore.include.visual2.IS,
      instore.include.visual2.visualType
    );
    visual.verifyVisualHash(
      instore.include.visual3.visualPosition,
      instore.include.visual3.hash,
      instore.include.visual3.IS,
      instore.include.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['35517', '0.00', '€0.67', '€0.05']);
    filter.verifyCurrentParametersForTelco('eventType', 'IN-STORE', false);

    filter.excludeFilterCheck();
    cy.wait(10000);
    visual.verifyVisualHash(
      instore.exclude.visual1.visualPosition,
      instore.exclude.visual1.hash,
      instore.exclude.visual1.IS,
      instore.exclude.visual1.visualType
    );
    visual.verifyVisualHash(
      instore.exclude.visual2.visualPosition,
      instore.exclude.visual2.hash,
      instore.exclude.visual2.IS,
      instore.exclude.visual2.visualType
    );
    visual.verifyVisualHash(
      instore.exclude.visual3.visualPosition,
      instore.exclude.visual3.hash,
      instore.exclude.visual3.IS,
      instore.exclude.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['1013057', '0.08', '€12.69', '€0.88']);
    filter.verifyCurrentParametersForTelco('eventType', 'IN-STORE', true);

    // uncheck the applied 'IN-STORE' filter
    // filter.interact_checkbox("div.control-container li:nth-child(1) div > ul > li input[data-value='IN-STORE']", false);
  });

  // prettier-ignore
  it('Check forward, backward and reset buttons', () => {
    filter.filterControlForward();
    visual.verifyVisualHash(
      instore.exclude.visual1.visualPosition,
      instore.exclude.visual1.hash,
      instore.exclude.visual1.IS,
      instore.exclude.visual1.visualType
    );
    visual.verifyVisualHash(
      instore.exclude.visual2.visualPosition,
      instore.exclude.visual2.hash,
      instore.exclude.visual2.IS,
      instore.exclude.visual2.visualType
    );
    visual.verifyVisualHash(
      instore.exclude.visual3.visualPosition,
      instore.exclude.visual3.hash,
      instore.exclude.visual3.IS,
      instore.exclude.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['1013057', '0.08', '€12.69', '€0.88']);

    filter.filterControlBack();
    cy.wait(3000);
    visual.verifyVisualHash(
      instore.include.visual1.visualPosition,
      instore.include.visual1.hash,
      instore.include.visual1.IS,
      instore.include.visual1.visualType
    );
    visual.verifyVisualHash(
      instore.include.visual2.visualPosition,
      instore.include.visual2.hash,
      instore.include.visual2.IS,
      instore.include.visual2.visualType
    );
    visual.verifyVisualHash(
      instore.include.visual3.visualPosition,
      instore.include.visual3.hash,
      instore.include.visual3.IS,
      instore.include.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['35517', '0.00', '€0.67', '€0.05']);

    filter.filterControlForward();
    cy.wait(3000);
    visual.verifyVisualHash(
      instore.exclude.visual1.visualPosition,
      instore.exclude.visual1.hash,
      instore.exclude.visual1.IS,
      instore.exclude.visual1.visualType
    );
    visual.verifyVisualHash(
      instore.exclude.visual2.visualPosition,
      instore.exclude.visual2.hash,
      instore.exclude.visual2.IS,
      instore.exclude.visual2.visualType
    );
    visual.verifyVisualHash(
      instore.exclude.visual3.visualPosition,
      instore.exclude.visual3.hash,
      instore.exclude.visual3.IS,
      instore.exclude.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['1013057', '0.08', '€12.69', '€0.88']);

    filter.filterControlReset();
    cy.wait(3000);
    visual.verifyVisualHash(
      instore.reset.visual1.visualPosition,
      instore.reset.visual1.hash,
      instore.reset.visual1.IS,
      instore.reset.visual1.visualType
    );
    visual.verifyVisualHash(
      instore.reset.visual2.visualPosition,
      instore.reset.visual2.hash,
      instore.reset.visual2.IS,
      instore.reset.visual2.visualType
    );
    visual.verifyVisualHash(
      instore.reset.visual3.visualPosition,
      instore.reset.visual3.hash,
      instore.reset.visual3.IS,
      instore.reset.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['1048574', '0.08', '€13.37', '€0.92']);
    filter.verifyCurrentParametersForTelco('eventType', 'No parameters');
  });

  // prettier-ignore
  it('Check ONLINE filter from Event Type Filter of Telco Dashboard and verify current parameters with exclude feature', () => {
    filter.applyFilterToTelcoDashboard(['ONLINE']);
    cy.wait(3000);
    visual.verifyVisualHash(
      online.include.visual1.visualPosition,
      online.include.visual1.hash,
      online.include.visual1.IS,
      online.include.visual1.visualType
    );
    visual.verifyVisualHash(
      online.include.visual2.visualPosition,
      online.include.visual2.hash,
      online.include.visual2.IS,
      online.include.visual2.visualType
    );
    visual.verifyVisualHash(
      online.include.visual3.visualPosition,
      online.include.visual3.hash,
      online.include.visual3.IS,
      online.include.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['345864', '0.03', '€0.02', '€0.00']);
    filter.verifyCurrentParametersForTelco('eventType', 'ONLINE', false);

    filter.excludeFilterCheck();
    cy.wait(10000);
    visual.verifyVisualHash(
      online.exclude.visual1.visualPosition,
      online.exclude.visual1.hash,
      online.exclude.visual1.IS,
      online.exclude.visual1.visualType
    );
    visual.verifyVisualHash(
      online.exclude.visual2.visualPosition,
      online.exclude.visual2.hash,
      online.exclude.visual2.IS,
      online.exclude.visual2.visualType
    );
    visual.verifyVisualHash(
      online.exclude.visual3.visualPosition,
      online.exclude.visual3.hash,
      online.exclude.visual3.IS,
      online.exclude.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['702710', '0.05', '€13.35', '€0.92']);
    filter.verifyCurrentParametersForTelco('eventType', 'ONLINE', true);
  });

  // prettier-ignore
  it('Check forward, backward and reset buttons', () => {
    filter.filterControlForward();
    visual.verifyVisualHash(
      online.exclude.visual1.visualPosition,
      online.exclude.visual1.hash,
      online.exclude.visual1.IS,
      online.exclude.visual1.visualType
    );
    visual.verifyVisualHash(
      online.exclude.visual2.visualPosition,
      online.exclude.visual2.hash,
      online.exclude.visual2.IS,
      online.exclude.visual2.visualType
    );
    visual.verifyVisualHash(
      online.exclude.visual3.visualPosition,
      online.exclude.visual3.hash,
      online.exclude.visual3.IS,
      online.exclude.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['702710', '0.05', '€13.35', '€0.92']);

    filter.filterControlBack();
    cy.wait(3000);
    visual.verifyVisualHash(
      online.include.visual1.visualPosition,
      online.include.visual1.hash,
      online.include.visual1.IS,
      online.include.visual1.visualType
    );
    visual.verifyVisualHash(
      online.include.visual2.visualPosition,
      online.include.visual2.hash,
      online.include.visual2.IS,
      online.include.visual2.visualType
    );
    visual.verifyVisualHash(
      online.include.visual3.visualPosition,
      online.include.visual3.hash,
      online.include.visual3.IS,
      online.include.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['345864', '0.03', '€0.02', '€0.00']);

    filter.filterControlForward();
    cy.wait(3000);
    visual.verifyVisualHash(
      online.exclude.visual1.visualPosition,
      online.exclude.visual1.hash,
      online.exclude.visual1.IS,
      online.exclude.visual1.visualType
    );
    visual.verifyVisualHash(
      online.exclude.visual2.visualPosition,
      online.exclude.visual2.hash,
      online.exclude.visual2.IS,
      online.exclude.visual2.visualType
    );
    visual.verifyVisualHash(
      online.exclude.visual3.visualPosition,
      online.exclude.visual3.hash,
      online.exclude.visual3.IS,
      online.exclude.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['702710', '0.05', '€13.35', '€0.92']);
    filter.verifyDashboardFilter(['ONLINE'], true);

    filter.filterControlReset();
    cy.wait(3000);
    visual.verifyVisualHash(
      instore.reset.visual1.visualPosition,
      instore.reset.visual1.hash,
      instore.reset.visual1.IS,
      instore.reset.visual1.visualType
    );
    visual.verifyVisualHash(
      online.reset.visual2.visualPosition,
      online.reset.visual2.hash,
      online.reset.visual2.IS,
      online.reset.visual2.visualType
    );
    visual.verifyVisualHash(
      online.reset.visual3.visualPosition,
      online.reset.visual3.hash,
      online.reset.visual3.IS,
      online.reset.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['1048574', '0.08', '€13.37', '€0.92']);
    filter.verifyCurrentParametersForTelco('eventType', 'No parameters');
  });

  // prettier-ignore
  it('Check QOS filter from Event Type Filter of Telco Dashboard and verify current parameters with exclude feature', () => {
    filter.applyFilterToTelcoDashboard(['QOS']);
    cy.wait(1000);
    visual.verifyVisualHash(
      qos.include.visual1.visualPosition,
      qos.include.visual1.hash,
      qos.include.visual1.IS,
      qos.include.visual1.visualType
    );
    visual.verifyVisualHash(
      qos.include.visual2.visualPosition,
      qos.include.visual2.hash,
      qos.include.visual2.IS,
      qos.include.visual2.visualType
    );
    visual.verifyVisualHash(
      qos.include.visual3.visualPosition,
      qos.include.visual3.hash,
      qos.include.visual3.IS,
      qos.include.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['659794', '0.05', '€12.54', '€0.86']);
    filter.verifyCurrentParametersForTelco('eventType', 'QOS', false);

    filter.excludeFilterCheck();
    cy.wait(10000);
    visual.verifyVisualHash(
      qos.exclude.visual1.visualPosition,
      qos.exclude.visual1.hash,
      qos.exclude.visual1.IS,
      qos.exclude.visual1.visualType
    );
    visual.verifyVisualHash(
      qos.exclude.visual2.visualPosition,
      qos.exclude.visual2.hash,
      qos.exclude.visual2.IS,
      qos.exclude.visual2.visualType
    );
    visual.verifyVisualHash(
      qos.exclude.visual3.visualPosition,
      qos.exclude.visual3.hash,
      qos.exclude.visual3.IS,
      qos.exclude.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['388780', '0.03', '€0.83', '€0.06']);
    filter.verifyCurrentParametersForTelco('eventType', 'QOS', true);
  });

  // prettier-ignore
  it('Check forward, backward and reset buttons', () => {
    filter.filterControlForward();
    visual.verifyVisualHash(
      qos.exclude.visual1.visualPosition,
      qos.exclude.visual1.hash,
      qos.exclude.visual1.IS,
      qos.exclude.visual1.visualType
    );
    visual.verifyVisualHash(
      qos.exclude.visual2.visualPosition,
      qos.exclude.visual2.hash,
      qos.exclude.visual2.IS,
      qos.exclude.visual2.visualType
    );
    visual.verifyVisualHash(
      qos.exclude.visual3.visualPosition,
      qos.exclude.visual3.hash,
      qos.exclude.visual3.IS,
      qos.exclude.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['388780', '0.03', '€0.83', '€0.06']);

    filter.filterControlBack();
    cy.wait(3000);
    visual.verifyVisualHash(
      qos.include.visual1.visualPosition,
      qos.include.visual1.hash,
      qos.include.visual1.IS,
      qos.include.visual1.visualType
    );
    visual.verifyVisualHash(
      qos.include.visual2.visualPosition,
      qos.include.visual2.hash,
      qos.include.visual2.IS,
      qos.include.visual2.visualType
    );
    visual.verifyVisualHash(
      qos.include.visual3.visualPosition,
      qos.include.visual3.hash,
      qos.include.visual3.IS,
      qos.include.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['659794', '0.05', '€12.54', '€0.86']);

    filter.filterControlForward();
    cy.wait(3000);
    visual.verifyVisualHash(
      qos.exclude.visual1.visualPosition,
      qos.exclude.visual1.hash,
      qos.exclude.visual1.IS,
      qos.exclude.visual1.visualType
    );
    visual.verifyVisualHash(
      qos.exclude.visual2.visualPosition,
      qos.exclude.visual2.hash,
      qos.exclude.visual2.IS,
      qos.exclude.visual2.visualType
    );
    visual.verifyVisualHash(
      qos.exclude.visual3.visualPosition,
      qos.exclude.visual3.hash,
      qos.exclude.visual3.IS,
      qos.exclude.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['388780', '0.03', '€0.83', '€0.06']);

    filter.filterControlReset();
    cy.wait(3000);
    visual.verifyVisualHash(
      instore.reset.visual1.visualPosition,
      instore.reset.visual1.hash,
      instore.reset.visual1.IS,
      instore.reset.visual1.visualType
    );
    visual.verifyVisualHash(
      qos.reset.visual2.visualPosition,
      qos.reset.visual2.hash,
      qos.reset.visual2.IS,
      qos.reset.visual2.visualType
    );
    visual.verifyVisualHash(
      qos.reset.visual3.visualPosition,
      qos.reset.visual3.hash,
      qos.reset.visual3.IS,
      qos.reset.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['1048574', '0.08', '€13.37', '€0.92']);
    filter.verifyCurrentParametersForTelco('eventType', 'No parameters');
  });

  // prettier-ignore
  it('Check IN-STORE filter from Event Filter of Telco Dashboard and verify current parameters with exclude feature', () => {
    // applying IN-STORE filter from Event Filter
    filter.applyFilterToTelcoDashboard(['IN-STORE'], 2);
    cy.wait(8000);
    visual.verifyVisualHash(
      instore.include.visual1.visualPosition,
      instore.include.visual1.hash,
      instore.include.visual1.IS,
      instore.include.visual1.visualType
    );
    visual.verifyVisualHash(
      instore.include.visual2.visualPosition,
      instore.include.visual2.hash2,
      instore.include.visual2.IS2,
      instore.include.visual2.visualType
    );
    visual.verifyVisualHash(
      instore.include.visual3.visualPosition,
      instore.include.visual3.hash,
      instore.include.visual3.IS,
      instore.include.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['26493', '0.00', '€0.50', '€0.03']);
    filter.verifyCurrentParametersForTelco('event', 'IN-STORE', false, 2);

    filter.excludeFilterCheck(2);
    cy.wait(5000);
    visual.verifyVisualHash(
      instore.exclude.visual1.visualPosition,
      instore.exclude.visual1.hash,
      instore.exclude.visual1.IS,
      instore.exclude.visual1.visualType
    );
    visual.verifyVisualHash(
      instore.exclude.visual2.visualPosition,
      instore.exclude.visual2.hash2,
      instore.exclude.visual2.IS2,
      instore.exclude.visual2.visualType
    );
    visual.verifyVisualHash(
      instore.exclude.visual3.visualPosition,
      instore.exclude.visual3.hash2,
      instore.exclude.visual3.IS2,
      instore.exclude.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['1022081', '0.08', '€12.87', '€0.89']);
    filter.verifyCurrentParametersForTelco('event', 'IN-STORE', true, 2);
  });

  // prettier-ignore
  it('Check forward, backward and reset buttons', () => {
    filter.filterControlForward();
    visual.verifyVisualHash(
      instore.exclude.visual1.visualPosition,
      instore.exclude.visual1.hash,
      instore.exclude.visual1.IS,
      instore.exclude.visual1.visualType
    );
    visual.verifyVisualHash(
      instore.exclude.visual2.visualPosition,
      instore.exclude.visual2.hash2,
      instore.exclude.visual2.IS2,
      instore.exclude.visual2.visualType
    );
    visual.verifyVisualHash(
      instore.exclude.visual3.visualPosition,
      instore.exclude.visual3.hash2,
      instore.exclude.visual3.IS2,
      instore.exclude.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['1022081', '0.08', '€12.87', '€0.89']);

    filter.filterControlBack();
    cy.wait(5000);
    visual.verifyVisualHash(
      instore.include.visual1.visualPosition,
      instore.include.visual1.hash,
      instore.include.visual1.IS,
      instore.include.visual1.visualType
    );
    visual.verifyVisualHash(
      instore.include.visual2.visualPosition,
      instore.include.visual2.hash2,
      instore.include.visual2.IS2,
      instore.include.visual2.visualType
    );
    visual.verifyVisualHash(
      instore.include.visual3.visualPosition,
      instore.include.visual3.hash,
      instore.include.visual3.IS,
      instore.include.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['26493', '0.00', '€0.50', '€0.03']);

    filter.filterControlForward();
    cy.wait(5000);
    visual.verifyVisualHash(
      instore.exclude.visual1.visualPosition,
      instore.exclude.visual1.hash,
      instore.exclude.visual1.IS,
      instore.exclude.visual1.visualType
    );
    visual.verifyVisualHash(
      instore.exclude.visual2.visualPosition,
      instore.exclude.visual2.hash2,
      instore.exclude.visual2.IS2,
      instore.exclude.visual2.visualType
    );
    visual.verifyVisualHash(
      instore.exclude.visual3.visualPosition,
      instore.exclude.visual3.hash2,
      instore.exclude.visual3.IS2,
      instore.exclude.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['1022081', '0.08', '€12.87', '€0.89']);

    filter.filterControlReset();
    cy.wait(3000);
    visual.verifyVisualHash(
      instore.reset.visual1.visualPosition,
      instore.reset.visual1.hash,
      instore.reset.visual1.IS,
      instore.reset.visual1.visualType
    );
    visual.verifyVisualHash(
      instore.reset.visual2.visualPosition,
      instore.reset.visual2.hash,
      instore.reset.visual2.IS,
      instore.reset.visual2.visualType
    );
    visual.verifyVisualHash(
      instore.reset.visual3.visualPosition,
      instore.reset.visual3.hash,
      instore.reset.visual3.IS,
      instore.reset.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['1048574', '0.08', '€13.37', '€0.92']);
    filter.verifyCurrentParametersForTelco('event', 'No parameters');
  });

  // prettier-ignore
  it('Check ONLINE filter from Event Filter of Telco Dashboard and verify current parameters with exclude feature', () => {
    // applying ONLINE filter from Event Filter
    filter.applyFilterToTelcoDashboard(['ONLINE'], 2);
    cy.wait(8000);
    visual.verifyVisualHash(
      online.include.visual1.visualPosition,
      online.include.visual1.hash,
      online.include.visual1.IS,
      online.include.visual1.visualType
    );
    visual.verifyVisualHash(
      online.include.visual2.visualPosition,
      online.include.visual2.hash2,
      online.include.visual2.IS2,
      online.include.visual2.visualType
    );
    visual.verifyVisualHash(
      online.include.visual3.visualPosition,
      online.include.visual3.hash,
      online.include.visual3.IS,
      online.include.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['319315', '0.02', '€0.02', '€0.00']);
    filter.verifyCurrentParametersForTelco('event', 'ONLINE', false, 2);

    filter.excludeFilterCheck(2);
    cy.wait(5000);
    visual.verifyVisualHash(
      online.exclude.visual1.visualPosition,
      online.exclude.visual1.hash,
      online.exclude.visual1.IS,
      online.exclude.visual1.visualType
    );
    visual.verifyVisualHash(
      online.exclude.visual2.visualPosition,
      online.exclude.visual2.hash2,
      online.exclude.visual2.IS2,
      online.exclude.visual2.visualType
    );
    visual.verifyVisualHash(
      online.exclude.visual3.visualPosition,
      online.exclude.visual3.hash2,
      online.exclude.visual3.IS2,
      online.exclude.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['729259', '0.05', '€13.35', '€0.92']);
    filter.verifyCurrentParametersForTelco('event', 'ONLINE', true, 2);
  });

  // prettier-ignore
  it('Check forward, backward and reset buttons', () => {
    filter.filterControlForward();
    visual.verifyVisualHash(
      online.exclude.visual1.visualPosition,
      online.exclude.visual1.hash,
      online.exclude.visual1.IS,
      online.exclude.visual1.visualType
    );
    visual.verifyVisualHash(
      online.exclude.visual2.visualPosition,
      online.exclude.visual2.hash2,
      online.exclude.visual2.IS2,
      online.exclude.visual2.visualType
    );
    visual.verifyVisualHash(
      online.exclude.visual3.visualPosition,
      online.exclude.visual3.hash2,
      online.exclude.visual3.IS2,
      online.exclude.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['729259', '0.05', '€13.35', '€0.92']);

    filter.filterControlBack();
    cy.wait(5000);
    visual.verifyVisualHash(
      online.include.visual1.visualPosition,
      online.include.visual1.hash,
      online.include.visual1.IS,
      online.include.visual1.visualType
    );
    visual.verifyVisualHash(
      online.include.visual2.visualPosition,
      online.include.visual2.hash2,
      online.include.visual2.IS2,
      online.include.visual2.visualType
    );
    visual.verifyVisualHash(
      online.include.visual3.visualPosition,
      online.include.visual3.hash,
      online.include.visual3.IS,
      online.include.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['319315', '0.02', '€0.02', '€0.00']);

    filter.filterControlForward();
    cy.wait(5000);
    visual.verifyVisualHash(
      online.exclude.visual1.visualPosition,
      online.exclude.visual1.hash,
      online.exclude.visual1.IS,
      online.exclude.visual1.visualType
    );
    visual.verifyVisualHash(
      online.exclude.visual2.visualPosition,
      online.exclude.visual2.hash2,
      online.exclude.visual2.IS2,
      online.exclude.visual2.visualType
    );
    visual.verifyVisualHash(
      online.exclude.visual3.visualPosition,
      online.exclude.visual3.hash2,
      online.exclude.visual3.IS2,
      online.exclude.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['729259', '0.05', '€13.35', '€0.92']);

    filter.filterControlReset();
    cy.wait(3000);
    visual.verifyVisualHash(
      online.reset.visual1.visualPosition,
      online.reset.visual1.hash,
      online.reset.visual1.IS,
      online.reset.visual1.visualType
    );
    visual.verifyVisualHash(
      online.reset.visual2.visualPosition,
      online.reset.visual2.hash,
      online.reset.visual2.IS,
      online.reset.visual2.visualType
    );
    visual.verifyVisualHash(
      online.reset.visual3.visualPosition,
      online.reset.visual3.hash,
      online.reset.visual3.IS,
      online.reset.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['1048574', '0.08', '€13.37', '€0.92']);
    filter.verifyCurrentParametersForTelco('event', 'No parameters');
  });

  // prettier-ignore
  it('Check QOS filter from Event Filter of Telco Dashboard and verify current parameters with exclude feature', () => {
    // applying QOS filter from Event Filter
    filter.applyFilterToTelcoDashboard(['QOS'], 2);
    cy.wait(8000);
    visual.verifyVisualHash(
      qos.include.visual1.visualPosition,
      qos.include.visual1.hash2,
      qos.include.visual1.IS2,
      qos.include.visual1.visualType
    );
    visual.verifyVisualHash(
      qos.include.visual2.visualPosition,
      qos.include.visual2.hash2,
      qos.include.visual2.IS2,
      qos.include.visual2.visualType
    );
    visual.verifyVisualHash(
      qos.include.visual3.visualPosition,
      qos.include.visual3.hash,
      qos.include.visual3.IS,
      qos.include.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['158019', '0.01', '€3.00', '€0.21']);
    filter.verifyCurrentParametersForTelco('event', 'QOS', false, 2);

    filter.excludeFilterCheck(2);
    cy.wait(8000);
    visual.verifyVisualHash(
      qos.exclude.visual1.visualPosition,
      qos.exclude.visual1.hash2,
      qos.exclude.visual1.IS2,
      qos.exclude.visual1.visualType
    );
    visual.verifyVisualHash(
      qos.exclude.visual2.visualPosition,
      qos.exclude.visual2.hash2,
      qos.exclude.visual2.IS2,
      qos.exclude.visual2.visualType
    );
    visual.verifyVisualHash(
      qos.exclude.visual3.visualPosition,
      qos.exclude.visual3.hash2,
      qos.exclude.visual3.IS2,
      qos.exclude.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['890555', '0.07', '€10.37', '€0.71']);
    filter.verifyCurrentParametersForTelco('event', 'QOS', true, 2);
  });

  // prettier-ignore
  it('Check forward, backward and reset buttons', () => {
    filter.filterControlForward();
    visual.verifyVisualHash(
      qos.exclude.visual1.visualPosition,
      qos.exclude.visual1.hash2,
      qos.exclude.visual1.IS2,
      qos.exclude.visual1.visualType
    );
    visual.verifyVisualHash(
      qos.exclude.visual2.visualPosition,
      qos.exclude.visual2.hash2,
      qos.exclude.visual2.IS2,
      qos.exclude.visual2.visualType
    );
    visual.verifyVisualHash(
      qos.exclude.visual3.visualPosition,
      qos.exclude.visual3.hash2,
      qos.exclude.visual3.IS2,
      qos.exclude.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['890555', '0.07', '€10.37', '€0.71']);

    filter.filterControlBack();
    cy.wait(5000);
    visual.verifyVisualHash(
      qos.include.visual1.visualPosition,
      qos.include.visual1.hash2,
      qos.include.visual1.IS2,
      qos.include.visual1.visualType
    );
    visual.verifyVisualHash(
      qos.include.visual2.visualPosition,
      qos.include.visual2.hash2,
      qos.include.visual2.IS2,
      qos.include.visual2.visualType
    );
    visual.verifyVisualHash(
      qos.include.visual3.visualPosition,
      qos.include.visual3.hash,
      qos.include.visual3.IS,
      qos.include.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['158019', '0.01', '€3.00', '€0.21']);

    filter.filterControlForward();
    cy.wait(5000);
    visual.verifyVisualHash(
      qos.exclude.visual1.visualPosition,
      qos.exclude.visual1.hash2,
      qos.exclude.visual1.IS2,
      qos.exclude.visual1.visualType
    );
    visual.verifyVisualHash(
      qos.exclude.visual2.visualPosition,
      qos.exclude.visual2.hash2,
      qos.exclude.visual2.IS2,
      qos.exclude.visual2.visualType
    );
    visual.verifyVisualHash(
      qos.exclude.visual3.visualPosition,
      qos.exclude.visual3.hash2,
      qos.exclude.visual3.IS2,
      qos.exclude.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['890555', '0.07', '€10.37', '€0.71']);

    filter.filterControlReset();
    cy.wait(3000);
    visual.verifyVisualHash(
      qos.reset.visual1.visualPosition,
      qos.reset.visual1.hash,
      qos.reset.visual1.IS,
      qos.reset.visual1.visualType
    );
    visual.verifyVisualHash(
      qos.reset.visual2.visualPosition,
      qos.reset.visual2.hash,
      qos.reset.visual2.IS,
      qos.reset.visual2.visualType
    );
    visual.verifyVisualHash(
      qos.reset.visual3.visualPosition,
      qos.reset.visual3.hash,
      qos.reset.visual3.IS,
      qos.reset.visual3.visualType
    );
    filter.verifyTelcoKPIs(3, 4, ['1048574', '0.08', '€13.37', '€0.92']);
    filter.verifyCurrentParametersForTelco('event', 'No parameters');
  });
});
