import { logins } from 'lib/arctest';
import * as dashboard from 'lib/dashboard/dashboard_functions';
import * as filter from 'lib/filter';
import * as functions from 'lib/functions';
import * as imp_exp from 'lib/import_export';
import { CSSselector } from 'locators/common/CSSselector';

describe('Default Values', () => {
  const dashboardName = 'Clone of VELIKO - Fiscal Year - Customer Service Quality / Cost Dashboard';
  const dashboardFile =
    'Clone of VELIKO - Fiscal Year - Customer Service Quality  Cost Dashboard (1).json';

  before(() => {
    logins.silent();
  });

  it('Check that Send parameters with dataset scope is checked', () => {
    dashboard.deleteDashboard(dashboardName);
    imp_exp.import_artifacts('Arcengine', dashboardFile);
    dashboard.openDashboardforEdit(dashboardName);
    filter.configureDateFilterScope('sheet_visibility', 'current_dataset');
    cy.intercept('POST', '/arc/reports/savedashboard').as('savedashboard');
    cy.get(CSSselector.Save).click({ force: true });
    cy.wait('@savedashboard')
      .its('response.statusCode')
      .should('eq', 200);
    // cy.reload();
  });

  it('Check IN-STORE filter of Telco Dashboard and verify current parameters with exclude feature', () => {
    filter.uncheckDataScopeofFilters(2);
    cy.reload();
    filter.verifyDatasetScopeofFilter(['IN-STORE', 'ONLINE', 'QOS'], 2);
    // filter.excludeFilter();
    // filter.verifyDashboardFilter(['IN-STORE'], true);
    // filter.verifyCurrentParametersForTelco('IN-STORE', true);
  });

  // it('Check ONLINE filter of Telco Dashboard and verify current parameters with exclude feature', () => {
  // filter.applyFilterToTelcoDashboard(['ONLINE']);
  //     filter.verifyDashboardFilter(['ONLINE']);
  //     filter.verifyCurrentParametersForTelco('ONLINE', false);

  //     filter.excludeFilter();
  //     filter.verifyDashboardFilter(['ONLINE'], true);
  //     filter.verifyCurrentParametersForTelco('ONLINE', true);
  // });

  // it('Check QOS filter of Telco Dashboard and verify current parameters with exclude feature', () => {
  //     filter.applyFilterToTelcoDashboard(['QOS']);
  //     filter.verifyDashboardFilter(['QOS']);
  //     filter.verifyCurrentParametersForTelco('QOS', false);

  //     filter.excludeFilter();
  //     filter.verifyDashboardFilter(['QOS'], true);
  //     filter.verifyCurrentParametersForTelco('QOS', true);
  // });
});
