import * as arctest from 'lib/arctest';

describe.skip('Default Values - open bug ARC-11603.', () => {
  function selectItem(s: string) {
    cy.get(arctest.screen.builder.picklistItem(s)).click();
  }

  function verifyTableContents(data: string[]) {
    cy.get(arctest.screen.builder.locators.tablevisual)
      .find('td')
      .should('have.length', data.length);

    cy.get(arctest.screen.builder.locators.tablevisual)
      .find('td')
      .each(($el, i, $list) => {
        const l = $el.text().trim();
        expect(l).equals(data[i]);
      });
  }

  it('default picklist selections', () => {
    arctest.logins.silent();
    arctest.misc.newDashboardEnterModal(
      Cypress.env('smokeConnectionName'),
      'US State Populations Over Time'
    );

    arctest.screen.builder.modal.addShelfColumn('dimensions_shelf', 'state');
    arctest.screen.builder.modal.addShelfColumn('aggregates_shelf', 'population');

    cy.intercept('POST', '/arc/sqlrun/jsonselect_parallel_async/*').as('jsonselect');
    arctest.screen.builder.modal.refreshVisual();
    cy.wait('@jsonselect');
    cy.get(arctest.screen.builder.modal.locators.refresh_icon).should('be.visible');

    arctest.screen.builder.modal.saveVisual();

    arctest.screen.builder.addFilter(['state']);

    cy.get(arctest.screen.builder.locators.picklist_dropdown).click();

    cy.intercept('POST', '/arc/sqlrun/jsonselect_parallel_async/*').as('jsonselect');
    selectItem('AR');
    cy.wait('@jsonselect');
    selectItem('CA');
    cy.wait('@jsonselect');

    // Click somewhere outside the filter to make it collapse
    cy.get('#main .arc-dashboard-title-container').click();

    const dataArCa = ['AR', '24,287,591', 'CA', '190,701,986'];
    const dataMo = ['MO', '51,787,369'];
    const dataMoCa = ['CA', '190,701,986', 'MO', '51,787,369'];

    verifyTableContents(dataArCa);

    arctest.screen.builder.enterDashboardTitle('cypress default picklist selections');

    cy.intercept('POST', '/arc/reports/savedashboard').as('savedashboard');
    cy.get(arctest.screen.builder.locators.save_btn).click();
    cy.wait('@savedashboard');

    // Wait for the VIEW button to show up
    cy.get(arctest.screen.builder.locators.view_btn);

    // Reload the page and confirm filters apply
    cy.reload();
    cy.url().should('include', '/arc/apps/builder/');

    verifyTableContents(dataArCa);

    // Go to view mode and confirm filters apply
    cy.get(arctest.screen.builder.locators.view_btn).click();
    cy.url().should('include', '/arc/apps/app/');

    verifyTableContents(dataArCa);

    // Set parameters via the url link
    cy.url().then((baseUrl) => {
      let url = baseUrl + '?param.state=MO';
      cy.visit(url);

      verifyTableContents(dataMo);

      url = baseUrl + "?param.state.data='MO'%2C%20'CA'";
      cy.visit(url);

      verifyTableContents(dataMoCa);
    });
  });
});
