import { logins } from 'lib/arctest';
import * as functions from 'lib/functions';
import * as imp_exp from 'lib/import_export';
import { CSSselector } from 'locators/common/CSSselector';

const dataconnection = 'samples';
const visualFile = 'Cereals Visual.json';

describe('import and export visual test: ARC-8014 and ARC-8017', () => {
  before(() => {
    logins.silent();
  });

  afterEach(() => {
    cy.window().then(
      (win: Window) =>
        (win.onbeforeunload = () => {
          return;
        })
    );
  });
  after(() => {
    cy.window().then(
      (win: Window) =>
        (win.onbeforeunload = () => {
          return;
        })
    );
  });

  it('Test 1: Import a linked visual ARC-8017 ', () => {
    imp_exp.import_artifacts(dataconnection, visualFile);
    functions.navigate_to_visuals();
    cy.reload();
    cy.get(`${CSSselector.Visuals_all}`).click();
    cy.get(CSSselector.listview_Visualspage).click();
    const visualName = visualFile.replace('.json', '');
    cy.contains(visualName);
  });

  it('Test 2: Export a linked visual ARC-8014 ', () => {
    functions.navigate_to_visuals();
    cy.get(CSSselector.Visuals_all).click();
    cy.get(CSSselector.listview_Visualspage).click();
    imp_exp.export_linked_visual('Cereals Visual');
  });
});
