import { jobs } from 'fixtures/locators/jobs';
import { goToJobSchedulePage } from 'lib/functions';
import { silent } from 'lib/logins';
import { clickOnFirstJobName, configureEmailSettings, createEmailJob, editEmailJob, JobType } from './utils';

describe('Job Detail Page - Edit Threshold Email', () => {
  before(() => {
    silent();
  });

  context('Check Adhoc Email Job on Job Detail Page', () => {
    before(() => {
      configureEmailSettings();
      createEmailJob(JobType.Threshold);
      goToJobSchedulePage();
      clickOnFirstJobName('scheduledJobsTable');
    });

    it('Should edit the Threshold Email and display the changes', () => {
      cy.get(jobs.job_actions).click();
      cy.get(jobs.job_actions_edit).click();

      editEmailJob();

      cy.log('Check edited data');
      cy.get(jobs.job_name).should('contain', 'EDITED');
      cy.get(jobs.job_schedule).should('contain', 'Weekly');
      cy.get(jobs.details_toggle).click();
      cy.get(jobs.email_subject).should('contain', 'EDITED');
      cy.get(jobs.email_message).should('contain', 'EDITED');
    });
  });
});
