import { jobs } from 'fixtures/locators/jobs';
import { goto_job_status } from 'lib/functions';
import { silent } from 'lib/logins';
import { setSiteSettingCheckbox } from 'lib/settings';
import { clickOnFirstJobName, configureEmailSettings, createExtractJob, extractJob } from './utils';

describe('Extract Job Test - Job Detail Page', () => {
  before(() => {
    silent();
  });

  context('Check Extract Job on Job Detail Page', () => {
    before(() => {
      configureEmailSettings();
      setSiteSettingCheckbox('Enable Data Extracts', true);
      createExtractJob();
      goto_job_status();
      clickOnFirstJobName('runsTable');
    });

    it('Should display information about the Extract Job', () => {
      cy.get(jobs.job_name).should('contain', 'Data Extract');

      cy.get(jobs.job_type).should('have.text', 'Data Extract');
      cy.get(jobs.job_interval).should('have.text', 'Adhoc');
      cy.get(jobs.job_owner).should('have.text', 'vizapps_admin');

      cy.get(jobs.details_toggle).click();
      cy.contains('Data Extract Details');

      cy.get(jobs.extract.extract_owner).should('have.text', 'vizapps_admin');
      cy.get(jobs.extract.src_dataset).should('have.text', extractJob.srcDsName);
      cy.get(jobs.extract.tgt_connection).should('have.text', extractJob.tgtConnName);
      cy.get(jobs.extract.tgt_table).should(
        'have.text',
        `${extractJob.tgtDbName}.${extractJob.tgtTableName}`
      );
    });
  });
});
