import { BackendAPI } from 'lib/backend-api';

const username = 'username';
const password = 'password';
const newPassword = 'newPassword';

describe('First login test', () => {
  before(() => {
    BackendAPI.users.create(
      {
        username,
        password,
      },
      {
        shouldChangePassword: true,
        shouldSeenWhatSNewModal: false,
      }
    );
  });

  it('should login via the UI', () => {
    cy.visit('/arc/apps/home');
    cy.get('[data-test-id="username"]').type(username);
    cy.get('[data-test-id="password"]').type(password);
    cy.get('[data-test-id="submit"]').click();

    cy.get('#confirmPassword').type(newPassword);
    cy.get('#password').type(password);
    cy.get('#newPassword').type(newPassword);
    cy.intercept('PUT', '/arc/apps/users_api/username').as('changePassword');
    cy.get('#change-password-submit-button').click();
    cy.wait('@changePassword');

    cy.visit('/arc/apps/home');
    cy.get('[data-test-id="arc-gotit-btn"]').click();

    cy.get('[data-test-id="navbar-user-dropdown-toggle"]').click();
    cy.get('[data-test-id="logout"]').click();

    cy.get('[data-test-id="username"]').type(username);
    cy.get('[data-test-id="password"]').type(newPassword);
    cy.get('[data-test-id="submit"]').click();

    cy.get('[data-test-id="navbar-user-dropdown-toggle"]');
    cy.get('[data-test-id="arc-gotit-btn"]').should('not.exist');
  });
});
