import { logins } from 'lib/arctest';

const userAgent =
  'Mozilla/5.0 (Linux; Android 13; Pixel 7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/116.0.0.0 Mobile Safari/537.36';

describe(
  'smoke tests for mobile',
  {
    viewportHeight: 915,
    viewportWidth: 412,
  },
  () => {
    before(() => {
      logins.silent();
    });

    it('should load mobile home page', () => {
      cy.visit('/', {
        headers: {
          'user-agent': userAgent,
        },
      });

      cy.contains('My Favorites');
    });

    it('should load mobile dashboards', () => {
      cy.visit('/', {
        headers: {
          'user-agent': userAgent,
        },
      });

      cy.contains('My Favorites').click();
      cy.contains('All').click();
      cy.contains('State of NYC').click();

      cy.contains('Number of deficienciesper county');
    });
  }
);
