import { logins } from 'lib/arctest';
import * as dashboards from 'lib/dashboard';
import { Dashboard, ShelfTypes, SortOptions } from 'lib/dashboard/dashboards_interfaces';
import * as functions from 'lib/functions';
import * as visuals from 'lib/visual';

const connectionName = Cypress.env('smokeConnectionName');
const datasetName1 = 'US State Populations Over Time';
const datasetName2 = 'Iris';

const dashboard: Dashboard = {
  title: 'simple_area_visual_dashboard_title',
  subTitle: 'simple_area_visual_dashboard_subtitle',
  sheets: [
    {
      sheet_name: 'sheet1',
      sheet_number: 1,
      visuals: [
        {
          name: 'areavisual1',
          connection_name: connectionName,
          dataset_name: datasetName1,
          visual_type: '.chart-icon-trellis-areas',
          visual_title: 'simple_area_visual1',
          linked: 'false',
          is: [
            'setTransform',
            'translate',
            'globalAlpha',
            'lineWidth',
            'font',
            'clearRect',
            'fillStyle',
            'strokeStyle',
            'beginPath',
            'moveTo',
            'lineTo',
            'lineTo',
            'lineTo',
            'closePath',
            'fill',
            'fillStyle',
            'strokeStyle',
            'beginPath',
            'moveTo',
            'lineTo',
            'lineTo',
            'lineTo',
            'closePath',
            'fill',
            'fillStyle',
            'strokeStyle',
            'beginPath',
            'moveTo',
            'lineTo',
            'lineTo',
            'lineTo',
            'closePath',
            'fill',
            'fillStyle',
            'strokeStyle',
            'beginPath',
            'moveTo',
            'lineTo',
            'lineTo',
            'lineTo',
            'closePath',
            'fill',
            'fillStyle',
            'strokeStyle',
            'beginPath',
            'moveTo',
            'lineTo',
            'lineTo',
            'lineTo',
            'closePath',
            'fill',
            'fillStyle',
            'strokeStyle',
            'beginPath',
            'moveTo',
            'lineTo',
            'lineTo',
            'lineTo',
            'closePath',
            'fill',
            'fillStyle',
            'strokeStyle',
            'beginPath',
            'moveTo',
            'lineTo',
            'lineTo',
            'lineTo',
            'closePath',
            'fill',
            'fillStyle',
            'strokeStyle',
            'beginPath',
            'moveTo',
            'lineTo',
            'lineTo',
            'lineTo',
            'closePath',
            'fill',
            'fillStyle',
            'strokeStyle',
            'beginPath',
            'moveTo',
            'lineTo',
            'lineTo',
            'lineTo',
            'closePath',
            'fill',
            'fillStyle',
            'strokeStyle',
            'beginPath',
            'moveTo',
            'lineTo',
            'lineTo',
            'lineTo',
            'closePath',
            'fill',
            'fillStyle',
            'strokeStyle',
            'beginPath',
            'moveTo',
            'lineTo',
            'lineTo',
            'lineTo',
            'closePath',
            'fill',
            'fillStyle',
            'strokeStyle',
            'beginPath',
            'moveTo',
            'lineTo',
            'lineTo',
            'lineTo',
            'closePath',
            'fill',
            'fillStyle',
            'strokeStyle',
            'beginPath',
            'moveTo',
            'lineTo',
            'lineTo',
            'lineTo',
            'closePath',
            'fill',
            'fillStyle',
            'strokeStyle',
            'beginPath',
            'moveTo',
            'lineTo',
            'lineTo',
            'lineTo',
            'closePath',
            'fill',
          ],
          hash: '8739d8c2b18d8a246c0bd95de5f02ae5',
          data: {
            fields: [
              {
                field_name: 'state',
                field_shelf: ShelfTypes.X,
                sort: SortOptions.ASCENDING,
              },
              {
                field_name: 'population',
                field_shelf: ShelfTypes.Y,
                sort: SortOptions.ASCENDING,
                field_aggregate: 'Sum',
              },
              {
                field_name: 'year',
                field_shelf: ShelfTypes.COLOR,
              },
              {
                field_name: 'population',
                field_shelf: ShelfTypes.TOOLTIP,
                sort: SortOptions.ASCENDING,
                field_aggregate: 'Sum',
              },
              {
                field_name: 'state',
                field_shelf: ShelfTypes.DRILL,
                alias: 'STATE',
              },
              {
                field_name: 'state',
                field_shelf: ShelfTypes.FILTERS,
                field_pick_filter: {
                  values: ['CA', 'NY'],
                },
              },
            ],
          },
        },
        {
          name: 'area visual 2',
          connection_name: connectionName,
          dataset_name: datasetName2,
          visual_type: '.chart-icon-trellis-areas',
          visual_title: 'simple_area_visual2',
          linked: 'false',
          hash: '876d709ef4ba4a7307bbf582d998ada4',
          // prettier-ignore
          is: ['setTransform', 'translate', 'globalAlpha', 'lineWidth', 'font', 'clearRect', 'fillStyle', 'strokeStyle', 'beginPath', 'arc', 'stroke', 'fillStyle', 'strokeStyle', 'beginPath', 'arc', 'stroke', 'fillStyle', 'strokeStyle', 'beginPath', 'arc', 'stroke', 'fillStyle', 'strokeStyle', 'beginPath', 'arc', 'stroke', 'shadowBlur', 'shadowColor', 'textAlign', 'measureText', 'fillStyle', 'fillRect', 'fillStyle', 'fillText', 'measureText', 'fillStyle', 'fillRect', 'fillStyle', 'fillText', 'measureText', 'fillStyle', 'fillRect', 'fillStyle', 'fillText'],
          data: {
            fields: [
              {
                field_name: 'species',
                field_shelf: ShelfTypes.X,
                sort: SortOptions.ASCENDING,
              },
              {
                field_name: 'sepal_length',
                field_shelf: ShelfTypes.Y,
                sort: SortOptions.ASCENDING,
                field_aggregate: 'Sum',
              },
              {
                field_name: 'sepal_width',
                field_shelf: ShelfTypes.COLOR,
              },

              {
                field_name: 'sepal_ratio',
                field_shelf: ShelfTypes.COLOR,
              },

              {
                field_name: 'sepal_area',
                field_shelf: ShelfTypes.COLOR,
              },
              {
                field_name: 'species',
                field_shelf: ShelfTypes.TOOLTIP,
                sort: SortOptions.ASCENDING,
              },
              {
                field_name: 'species',
                field_shelf: ShelfTypes.DRILL,
                alias: 'SPECIES',
              },
              {
                field_name: 'species',
                field_shelf: ShelfTypes.LABEL,
                alias: 'SPECIES',
              },
              {
                field_name: 'species',
                field_shelf: ShelfTypes.FILTERS,
                field_pick_filter: {
                  values: ['setosa'],
                },
              },
            ],
          },
        },
      ],
    },
  ],
};

describe('Arcviz Area visuals tests.', () => {
  before(() => {
    logins.silent();
    cy.visit('/arc/apps/home');
  });

  context('Area visual tests', () => {
    it('Test 1: Create area visual', () => {
      dashboards.createDashboard(dashboard);
      cy.wait(2000);
      visuals.verifyVisual(dashboard);
    });
  });
});
