import { logins } from 'lib/arctest';
import * as dashboards from 'lib/dashboard';
import { Dashboard, ShelfTypes, SortOptions } from 'lib/dashboard/dashboards_interfaces';
import * as functions from 'lib/functions';
import { verifyVisual } from 'lib/visual';
import * as combo_functions from 'lib/visual/visual_bar_line_combo_area_group';

const connectionName = 'samples';
const datasetName = 'Restaurant Inspection SF';

const dashboard: Dashboard = {
  title: 'ARC-10390 Dashboard',
  subTitle: 'ARC-10390 Dashboard_subtitle',
  sheets: [
    {
      sheet_name: 'Sheet 1',
      sheet_number: 1,
      visuals: [
        {
          name: 'bars selection brush',
          connection_name: connectionName,
          dataset_name: datasetName,
          visual_type: '.chart-icon-trellis-bars',
          visual_title: 'ARC-10390',
          linked: 'false',
          data: {
            fields: [
              {
                field_name: 'inspection_date',
                field_shelf: ShelfTypes.X,
              },
              {
                field_name: 'Record Count',
                field_shelf: ShelfTypes.Y,
              },
            ],
          },
          is: [
            'setTransform',
            'translate',
            'globalAlpha',
            'font',
            'setTransform',
            'translate',
            'clearRect',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
            'fillStyle',
            'beginPath',
            'rect',
            'fill',
          ],
          hash: '0ba8efda756d4200b0f16c7bcfeec74b',
        },
      ],
    },
  ],
};

describe('Arcviz Bar visuals test suite.', () => {
  before(() => {
    logins.silent();
    cy.visit('/arc/apps/home');
  });

  context('ARC-10390', () => {
    it('Test 1: Create basic bar graph visual', () => {
      dashboards.createDashboard(dashboard);
      dashboards.openDashboardforEdit(dashboard.title);
      dashboards.editVisual();
      cy.log('setSelectionBrush');
      combo_functions.setSelectionBrush();
      cy.log('checkErrorMessage');
      dashboards.checkErrorMessage('edit');
      verifyVisual(dashboard);
    });
  });
});
