import * as dashboards from 'lib/dashboard';
import * as logins from 'lib/logins';
import * as visuals from 'lib/visual';
import { reverseColorPalette } from 'lib/visual';

const testDashbboardName = 'youCanDeleteMeBecauseIAmATestDashboard';

describe('Arcviz Bar visuals test suite.', () => {
  // done
  context('Bar graph visual tests colors tab tests', () => {
    before(() => {
      logins.silent();
    });

    beforeEach(() => {
      dashboards.deleteDashboard(testDashbboardName);
      dashboards.createBarVisual(testDashbboardName);
      dashboards.chooseVisualTab('colors');
    });

    it('Test 1: Reverse order of color palettes', () => {
      reverseColorPalette();
      // Should we detect any change?
      visuals.closeVisual(false);
    });

    it('Test 2: Choose color palettes', () => {
      cy.get('[data-test-id="settings-palette"]:nth-child(10)').click();
      visuals.closeVisual(false);
    });

    it('Test 3: Color opacity', () => {
      cy.get('[data-test-id="tab-Colors"]').within(() => {
        cy.get('[data-test-id="settings-slider-input"]').trigger('click', 'right');
      });
      visuals.closeVisual(false);
    });

    it('Test 4: Base colors on dimension values', () => {
      cy.get('[data-test-id="tab-Colors"]').within(() => {
        cy.get('[data-test-id="checkbox-fixed_color_legend"]').check();
      });
      visuals.closeVisual(false);
    });

    it('Test 5: Fix colors for specified', () => {
      cy.get('[data-test-id="tab-Colors"]').within(() => {
        cy.get('[data-test-id="fix-color-for-specified-checkbox"]');
        cy.get('[data-test-id="settings-slider-input"]').trigger('click', 'right');
      });
      visuals.closeVisual(false);
    });
  });
});
