import { logins } from 'lib/arctest';
import * as dashboards from 'lib/dashboard';
import { combinatedBarLineDashboard } from 'lib/dashboard/default_dashboard';
import * as combo_functions from 'lib/visual/visual_bar_line_combo_area_group';
const dashboard = combinatedBarLineDashboard;
describe('Arcviz Combined Bar Line visuals tests.', () => {
  context('Bar/Line visual tests colors tab tests', () => {
    before(() => {
      logins.silent();
      dashboards.createDashboard(dashboard);
    });

    it('Test 1: Reverse order of color palettes', () => {
      combo_functions.reverseColorPalette();
      dashboards.closeVisual(false);
    });

    it('Test 2: Choose color palettes', () => {
      combo_functions.chooseColorPalette();
      dashboards.closeVisual(false);
    });

    it('Test 3: Color opacity', () => {
      combo_functions.setColorOpacity();
      dashboards.closeVisual(false);
    });

    it('Test 4: Base colors on dimension values', () => {
      combo_functions.setFixedColorLegend();
      dashboards.closeVisual(false);
    });
  });
});
