import { logins } from 'lib/arctest';
import * as dashboards from 'lib/dashboard';
import { combinatedBarLineDashboard } from 'lib/dashboard/default_dashboard';
import * as combo_functions from 'lib/visual/visual_bar_line_combo_area_group';

const dashboard = combinatedBarLineDashboard;

describe('Arcviz Combined Bar Line visuals tests.', () => {
  context('Bar/Line visual tests data tab tests', () => {
    before(() => {
      cy.fixture('users.json').then((data) => {
        logins.silent(data.admin.username, data.admin.password);
      });

      dashboards.createDashboard(dashboard);
      dashboards.chooseVisualTab('data');
    });

    it('Test 1: Switch data set', () => {
      combo_functions.switchDataSet('Iris');
    });
  });
});
