import { logins } from 'lib/arctest';
import * as dashboards from 'lib/dashboard';
import { combinatedBarLineDashboard } from 'lib/dashboard/default_dashboard';
import { FontSizeSettingTestOptions } from 'lib/visual/fontsizeSetting';
import * as combo_functions from 'lib/visual/visual_bar_line_combo_area_group';
import * as visual_common_tests from 'lib/visual/visual_common_tests';

describe('Arcviz Combined Bar Line visuals tests.', () => {
  context('combo_visual_style_tests_risk1', () => {
    before(() => {
      logins.silent();
      dashboards.createDashboard(combinatedBarLineDashboard);
    });

    it('Test 1: Visual basic font type', () => {
      combo_functions.setVisualBasicFontType('arc-font-georgia');
    });

    it('Test 2: Visual basic font size', () => {
      combo_functions.setVisualBasicFontSize(combinatedBarLineDashboard.title, '30');
    });

    it('Test 3: Visual title font type', () => {
      combo_functions.setVisualTitleFontType('arc-font-comic-sans-ms');
    });

    it('Test 4: Visual title font size', () => {
      combo_functions.setVisualTitleFontSize(combinatedBarLineDashboard.title, '40');
    });

    it('Test 5: Visual title font weight', () => {
      combo_functions.setVisualTitleFontWeight('bold');
    });

    it('Test 6: Visual title alignment', () => {
      combo_functions.setVisualTitleFontAlignment('Center');
    });

    it('Test 7: Visual title hide in view mode', () => {
      combo_functions.setVisualTitleHide();
    });

    it('Test 8: Visual subtitle font', () => {
      combo_functions.setVisualSubtitleFontType(
        combinatedBarLineDashboard.title,
        'arc-font-helvetica'
      );
    });

    it('Test 9: Visual subtitle font size', () => {
      visual_common_tests.testSettingFontSizeHasTheDesiredEffect(
        FontSizeSettingTestOptions.SET_VISUAL_FONTSIZE,
        50
      );
    });

    it('Test 10: Visual subtitle alignment', () => {
      combo_functions.setVisualSubtitleFontAlignment(combinatedBarLineDashboard.title, 'Right');
    });

    it('Test 11: Visual style tool tip  font', () => {
      combo_functions.setVisualSubtitleTTFontType('arc-font-tahoma');
    });

    it('Test 12: Visual style tooltip size ', () => {
      combo_functions.setVisualSubtitleTTFontSize(combinatedBarLineDashboard.title, '60');
    });
  });
});
