import { logins } from 'lib/arctest';
import * as dashboards from 'lib/dashboard';
import { Dashboard, ShelfTypes } from 'lib/dashboard/dashboards_interfaces';
import * as functions from 'lib/functions';
import { checkFeatureAvailable } from 'lib/functions';

const connectionName = 'curlyDefault';
const datasetName = 'Campaign';

const dashboard: Dashboard = {
  title: 'simple_flow_visual_dashboard',
  subTitle: 'simple_flow_visual_dashboard_subtitle',
  sheets: [
    {
      sheet_name: 'campaign sheet',
      sheet_number: 1,
      visuals: [
        {
          name: 'flowvisual1',
          connection_name: connectionName,
          dataset_name: datasetName,
          visual_type: '.chart-icon-flow',
          visual_title: 'simple_flow_visual',
          linked: 'false',
          data: {
            fields: [
              {
                field_name: 'timestamp',
                field_shelf: ShelfTypes.TIME,
              },
              {
                field_name: 'user_id',
                field_shelf: ShelfTypes.SESSION,
              },
              {
                field_name: 'event_id_lo',
                field_shelf: ShelfTypes.EVENTS_PATH,
              },

              {
                field_name: 'name',
                field_shelf: ShelfTypes.EVENTS_PATH,
              },

              {
                field_name: 'duration',
                field_shelf: ShelfTypes.EVENTS_PATH,
              },
              {
                field_name: 'Record Count',
                field_shelf: ShelfTypes.MEASURE,
              },
            ],
          },
        },
      ],
    },
  ],
};

describe.skip('Arcviz flow visuals tests.', () => {
  before(function() {
    checkFeatureAvailable(this, 'connection_curly');
    logins.silent();
    cy.visit('/arc/apps/home');
  });

  context('Grouped flow visual tests', () => {
    it('Test 1: Create basic flow visuals', () => {
      dashboards.createDashboard(dashboard);
    });
  });
});
