import { logins } from 'lib/arctest';
import { BackendAPI } from 'lib/backend-api';
import * as dashboards from 'lib/dashboard';
import * as combo_functions from 'lib/visual/visual_bar_line_combo_area_group';

const datasetName2 = 'Cereals';
const dashboardName = 'Grouped bar visual dashboard';

describe('Arcviz Grouped Bar visuals tests.', () => {
  context('Grouped bar visual tests data tab tests', () => {
    const cloneDashboardName = 'grobar_data_dashboard';
    before(() => {
      cy.fixture('users.json').then((data) => {
        logins.silent(data.admin.username, data.admin.password);
      });
      BackendAPI.dashboards.import({
        fileName: 'grouped_bars_dashboard.json',
        dataconnectionName: 'samples',
        workspaceName: 'Public',
        randomised: false,
      });
    });

    beforeEach(() => {
      dashboards.cloneDashboard(dashboardName, cloneDashboardName);
      dashboards.openDashboardforEdit(cloneDashboardName);
      dashboards.editVisual();
      dashboards.chooseVisualTab('settings');
    });

    it('Test 2: Switch data set', () => {
      combo_functions.switchDataSet(datasetName2);
    });
  });
});
