import { logins } from 'lib/arctest';
import * as dashboards from 'lib/dashboard';
import * as combo_functions from 'lib/visual/visual_bar_line_combo_area_group';

import { dashboardWithLineVisual } from '../../../../lib/dashboard/default_dashboard';

describe('Arcviz Line visuals tests.', () => {
  context('Line visual tests style tab tests', () => {
    before(() => {
      logins.silent();
      cy.visit('/');
      dashboards.createDashboard(dashboardWithLineVisual);
    });

    it('Test 1: Visual basic font type', () => {
      combo_functions.setVisualBasicFontType('arc-font-georgia');
    });

    it('Test 2: Visual basic font size', () => {
      combo_functions.setVisualBasicFontSize(dashboardWithLineVisual.title, '30');
    });

    it('Test 3: Visual title font type', () => {
      combo_functions.setVisualTitleFontType('arc-font-comic-sans-ms');
    });

    it('Test 4: Visual title font size', () => {
      combo_functions.setVisualTitleFontSize(dashboardWithLineVisual.title, '40');
    });

    it('Test 5: Visual title font weight', () => {
      combo_functions.setVisualTitleFontWeight('bold');
    });

    it('Test 6: Visual title alignment', () => {
      combo_functions.setVisualTitleFontAlignment('Center');
    });

    it('Test 7: Visual title hide in view mode', () => {
      combo_functions.setVisualTitleHide();
    });

    it('Test 8: Visual subtitle font', () => {
      combo_functions.setVisualSubtitleFontType(
        dashboardWithLineVisual.title,
        'arc-font-helvetica'
      );
    });

    it('Test 9: Visual subtitle font size', () => {
      combo_functions.setVisualSubtitleFontSize(dashboardWithLineVisual.title, '50');
    });

    it('Test 10: Visual subtitle alignment', () => {
      combo_functions.setVisualSubtitleFontAlignment(dashboardWithLineVisual.title, 'Right');
    });

    it('Test 11: Visual style tool tip  font', () => {
      combo_functions.setVisualSubtitleTTFontType('arc-font-tahoma');
    });

    it('Test 12: Visual style tooltip size ', () => {
      combo_functions.setVisualSubtitleTTFontSize(dashboardWithLineVisual.title, '60');
    });
  });
});
