import { logins } from 'lib/arctest';
import * as dashboards from 'lib/dashboard';
import { Dashboard, ShelfTypes, SortOptions } from 'lib/dashboard/dashboards_interfaces';
import * as functions from 'lib/functions';
import * as visual from 'lib/visual';

const connectionName = Cypress.env('smokeConnectionName');
const datasetName = 'US State Populations Over Time';

const dashboard: Dashboard = {
  title: 'simple_packedbubble_visual_dashboard',
  subTitle: 'simple_packed-bubble_visual_dashboard_subtitle',
  sheets: [
    {
      sheet_name: 'population sheet',
      sheet_number: 1,
      visuals: [
        {
          name: 'packedbubblevisual1',
          connection_name: connectionName,
          dataset_name: datasetName,
          visual_type: '.chart-icon-packed-bubbles',
          visual_title: 'simple_packedbubble_visual',
          linked: 'false',
          // prettier-ignore
          is: ['setTransform','translate','globalAlpha','font','textBaseline','textAlign','clearRect','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText','fillText','beginPath','arc','fillStyle','fill','fillStyle','measureText','beginPath','arc','fillStyle','fill','fillStyle','measureText'],
          hash: '167ff204fb29180f390b1ab25f8c23d0',
          data: {
            fields: [
              {
                field_name: 'state',
                field_shelf: ShelfTypes.DIMENSIONS,
                sort: SortOptions.ASCENDING,
              },
              {
                field_name: 'population',
                field_shelf: ShelfTypes.AGGREGATES,
                sort: SortOptions.ASCENDING,
                field_aggregate: 'Sum',
              },
              {
                field_name: 'state',
                field_shelf: ShelfTypes.COLOR,
              },
              // {
              //   field_name: 'year',
              //   field_shelf: ShelfTypes.TOOLTIP,
              // },
              // {
              //   field_name: 'year',
              //   field_shelf: ShelfTypes.FILTERS,
              //   field_pick_filter: {
              //     values: ['2010'],
              //   },
              // },
            ],
          },
        },
      ],
    },
  ],
};

describe('Arcviz Packed Bubble visuals tests.', () => {
  before(() => {
    logins.silent();
    cy.visit('/arc/apps/home');
  });
  afterEach(() => {
    cy.window().then(
      (win: Window) =>
        (win.onbeforeunload = () => {
          return;
        })
    );
  });


  context('Packed Bubble visual tests', () => {
    it('Test 1: Create basic packed bubble visuals', () => {
      dashboards.createDashboard(dashboard);
      visual.verifyVisual(dashboard);
    });
  });
});
