import { logins } from 'lib/arctest';
import * as dashboards from 'lib/dashboard';
import { Dashboard, ShelfTypes, SortOptions } from 'lib/dashboard/dashboards_interfaces';
import * as functions from 'lib/functions';
import * as visual from 'lib/visual';

const connectionName = Cypress.env('smokeConnectionName');
const databaseName = 'main';
const tableName = 'cereals';
const datasetName = 'Cereals';

const dashboard: Dashboard = {
  title: 'simple_pie_visual_dashboard',
  subTitle: 'simple_extension_visual_dashboard_subtitle',
  sheets: [
    {
      sheet_name: 'cereal sheet',
      sheet_number: 1,
      visuals: [
        {
          name: 'pievisual1',
          connection_name: connectionName,
          dataset_name: datasetName,
          visual_type: '.chart-icon-pie',
          visual_title: 'simple_pie_visual',
          linked: 'false',
          // prettier-ignore
          is: [
            'setTransform',
            'translate',
            'translate',
            'globalAlpha',
            'lineWidth',
            'strokeStyle',
            'font',
            'textBaseline',
            'textAlign',
            'clearRect',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText',
            'beginPath',
            'moveTo',
            'arc',
            'arc',
            'closePath',
            'stroke',
            'fillStyle',
            'fill',
            'fillStyle',
            'measureText'
          ],
          hash: 'e320a7dd6d23d89d4bfdba2680504317',
          data: {
            fields: [
              {
                field_name: 'cereal_name',
                field_shelf: ShelfTypes.DIMENSIONS,
              },
              {
                field_name: 'calories',
                field_shelf: ShelfTypes.AGGREGATES,
                field_aggregate: 'Sum',
                alias: 'Calories',
              },
              {
                field_name: 'complex_carbohydrates_grams',
                field_shelf: ShelfTypes.AGGREGATES,
                field_aggregate: 'Sum',
                alias: 'Carbohydrates',
              },
              {
                field_name: 'fat_grams',
                field_shelf: ShelfTypes.AGGREGATES,
                field_aggregate: 'Sum',
                alias: 'Fat',
              },
              {
                field_name: 'dietary_fiber_grams',
                field_shelf: ShelfTypes.AGGREGATES,
                field_aggregate: 'Sum',
                alias: 'Fiber',
              },
              {
                field_name: 'cups_per_serving',
                field_shelf: ShelfTypes.TOOLTIP,
              },
              {
                field_name: 'manufacturer',
                field_shelf: ShelfTypes.FILTERS,
                field_pick_filter: {
                  values: [],
                },
              },
            ],
          },
        },
      ],
    },
  ],
};

describe('Arcviz pie visuals tests.', () => {
  before(() => {
    logins.silent();
    cy.visit('/arc/apps/home');
  });
  afterEach(() => {
    cy.window().then(
      (win: Window) =>
        (win.onbeforeunload = () => {
          return;
        })
    );
  });

  // local method just for the test
  function get_time() {
    return new Date().getTime();
  }

  context('pie visual tests', () => {
    before(() => {
      // create dataset if it doesn't exist
      functions.createDatasetFromConnection(connectionName, databaseName, tableName, datasetName);
    });
    it('Test 1: Create basic pie visuals', () => {
      dashboards.createDashboard(dashboard);
      visual.verifyVisual(dashboard);
    });
  });
});
