import { BackendAPI } from 'lib/backend-api';
import * as dashboards from 'lib/dashboard';
import * as logins from 'lib/logins';
import * as visuals from 'lib/visual';
import { addNewColorRage } from 'tests/visuals/customer_bugs/VIZ-1060-table-visual-coloring/utility';
describe('Measure color tests.', () => {
  context('On Scatter visual measuring by range should work', () => {
    before(() => {
      logins.silent();
    });

    afterEach(() => {
      cy.window().then(
        (win: Window) =>
          (win.onbeforeunload = () => {
            return;
          })
      );
    });

    it('Tests Measure coloring works on scatter visual, with normal number and percentage values as well', () => {
      // NOTE: Keep it for safety. This dashboard was exported.

      // const dashboardWithOneDimension = {
      //   title: 'Scatter plot range color',
      //   subTitle: 'simple_scatter_visual_dashboard_subtitle',
      //   sheets: [
      //     {
      //       sheet_name: 'sheet1',
      //       sheet_number: 1,
      //       visuals: [
      //         {
      //           name: 'Numbers below 101 should be colored with red',
      //           connection_name: connectionName,
      //           dataset_name: datasetName,
      //           visual_type: '.chart-icon-scatter',
      //           visual_title: 'Numbers below 101 should be colored with red',
      //           linked: 'false',
      //           data: {
      //             fields: [
      //               {
      //                 field_name: 'manufacturer_code',
      //                 field_shelf: ShelfTypes.X,
      //                 sort: SortOptions.ASCENDING,
      //               },
      //               {
      //                 field_name: 'sugars_grams',
      //                 field_shelf: ShelfTypes.Y,
      //                 sort: SortOptions.ASCENDING,
      //               },
      //               {
      //                 field_name: 'sugars_grams',
      //                 field_shelf: ShelfTypes.COLOR,
      //               },
      //               {
      //                 field_name: 'sugars_grams',
      //                 field_shelf: ShelfTypes.TOOLTIP,
      //                 sort: SortOptions.ASCENDING,
      //               }
      //             ],
      //           },
      //         },
      //         {
      //           name: 'All the circles should be colored with red (101%)',
      //           connection_name: connectionName,
      //           dataset_name: datasetName,
      //           visual_type: '.chart-icon-scatter',
      //           visual_title: 'All the circles should be colored with red (101%)',
      //           linked: 'false',
      //           data: {
      //             fields: [
      //               {
      //                 field_name: 'manufacturer_code',
      //                 field_shelf: ShelfTypes.X,
      //                 sort: SortOptions.ASCENDING,
      //               },
      //               {
      //                 field_name: 'sugars_grams',
      //                 field_shelf: ShelfTypes.Y,
      //                 sort: SortOptions.ASCENDING,
      //               },
      //               {
      //                 field_name: 'sugars_grams',
      //                 field_shelf: ShelfTypes.COLOR,
      //               },
      //               {
      //                 field_name: 'sugars_grams',
      //                 field_shelf: ShelfTypes.TOOLTIP,
      //                 sort: SortOptions.ASCENDING,
      //               }
      //             ],
      //           },
      //         },
      //       ],
      //     },
      //   ],
      // };

      BackendAPI.dashboards
        .import({
          fileName: 'scatter_plot_range_color_prettified.json',
          dataconnectionName: 'samples',
          workspaceName: 'Public',
          randomised: true,
        })
        .then(({ dashboard }) => {
          const visualBuilderUrl = `/arc/apps/builder/${dashboard.id}`;
          // const visualViewUrl = visualBuilderUrl.replace('builder', 'app');
          cy.visit(visualBuilderUrl);

          // set and check normal, numeric color range on the first visual
          dashboards.editVisual(1);
          dashboards.chooseVisualTab('colors', true, 1);
          cy.get("[data-test-id='add-color-range']").click();
          addNewColorRage({ lower: undefined, upper: '101' }, 7);
          cy.get(
            '[data-test-id="app-selected-list"] [data-test-id="visual-list-item"]:nth-of-type(1)'
          ).matchImage();

          // set and check color percentage color range on the second visual
          dashboards.chooseVisualTab('colors', true, 2);
          cy.get("[data-test-id='add-color-range']").click();
          addNewColorRage({ lower: undefined, upper: '101%' }, 7);
          cy.get(
            '[data-test-id="app-selected-list"] [data-test-id="visual-list-item"]:nth-of-type(2)'
          )
            .scrollIntoView()
            .matchImage();
          visuals.closeVisual(false);
        });
    });
  });
});
