/*
 * Verify that the SQL builder visualization works
 * Assumes the existence of the 'US State Populations Over Time' dataset
 *   in the Cypress.env("smokeConnectionName") data connection
 */

import { logins } from 'lib/arctest';
import * as misc from 'lib/arctest/misc';

describe('barlinearea Viz', () => {
  before(() => {
    logins.silent();
    cy.visit('/');
  });

  it('visual: 1: bar Simple', () => {
    misc.drawIt('.chart-icon-trellis-bars');
  });

  it('visual: 2: line Simple', () => {
    misc.drawIt('.chart-icon-trellis-lines');
  });

  it('visual: 3: area Simple', () => {
    misc.drawIt('.chart-icon-trellis-areas');
  });

  it('visual: 4: stacked Bar', () => {
    misc.drawIt('.chart-icon-trellis-bars', true);
  });

  it('visual: 5: stacked Line', () => {
    misc.drawIt('.chart-icon-trellis-lines', true);
  });

  it('visual: 6: stacked Area', () => {
    misc.drawIt('.chart-icon-trellis-areas', true);
  });
});
