#!/bin/bash
#
# docker-cypress.sh
# This script will run cypress commands inside the cypress docker container using "docker-compose exec"
#
# The command that is built is similar to:
# docker-compose exec cypress bash -c '(cd /home/cypress ;  npx cypress run -s ./cypress/tests/smoke/first_login_test.ts --reporter mocha-multi-reporters --reporter-options configFile=reporters_config.json )'
#

scriptdir="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
dockerdir="${scriptdir}/../docker"

# must run docker-compose from the docker directory
cd ${dockerdir}

# Build the command
CMD_START="docker-compose exec -T cypress_${1} bash -c \"(cd /home/cypress ;"
CMD_END=")\""
CMD_ALL="${CMD_START} npx cypress ${@:2} --reporter mocha-multi-reporters --reporter-options configFile=./reporters_config.json ${CMD_END}"

# echo the command
echo ${CMD_ALL}

# run the command
eval ${CMD_ALL}
