#!/bin/bash
#
# docker-run-test.sh
#
# Sample for running arcviz cypress tests using docker-compose
#

scriptdir="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
cd ${scriptdir}

# Setup the docker directory
export ARCVIZ_IMAGE=arcadiadata_qa/arcviz:4.2.2.0-1526504253
for i in 1 2 3 4; do echo $i; ./../scripts/docker-setup-scale.sh $i; done

# Bring docker up
./docker-up-scale.sh

# wait for arcviz and cypress containers
for i in 1 2 3 4; do echo $i; ./../scripts/docker-wait-on-arcviz-scale.sh $i; done
for i in 1 2 3 4; do echo $i; ./../scripts/docker-wait-on-cypress-scale.sh $i; done

./docker-cypress.sh run -s ./cypress/tests/smoke/first_login_test.ts --reporter mocha-multi-reporters --reporter-options configFile=reporters_config.json
# Can run other tests here

# Shutdown docker
./docker-down.sh

