#!/bin/bash
#

set -x

scriptdir="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

dockerdir="${scriptdir}/../docker"

sourcedir="${scriptdir}/../cypress"
targetdir="${dockerdir}/mnt/cypress"

testsdir="${sourcedir}/tests"

arcviz_config_source_dir="${testsdir}/_arcviz_config"
arcviz_config_target_dir="${dockerdir}/mnt/arcviz_config"

files="cypress.json webpack.config.js prettier.config.js yarn.lock package.json tslint.json tsconfig.json reporters_config.json"

if [[ ! -d ${dockerdir}/mnt ]]; then
  mkdir ${dockerdir}/mnt
fi

if [[ ! -d ${targetdir} ]]; then
  mkdir ${targetdir}
  cp -r ${sourcedir} ${targetdir}
  cp -r ${scriptdir} ${targetdir}
  for f in ${files}; do
    cp ${scriptdir}/../${f} ${targetdir}
  done
  chmod -R a+w ${targetdir}

fi

if [[ ! -d ${arcviz_config_target_dir} ]]; then
  pushd ${dockerdir}
  if [[ ! -d mnt ]]; then
    mkdir mnt
  fi

  # mkdir -p ${arcviz_config_target_dir}
  cp -r ${arcviz_config_source_dir}/ ${arcviz_config_target_dir}
  #tar zxvf ${arcviz_config_source_dir}/default.tgz
  chmod -R a+w ${arcviz_config_target_dir}
  popd
fi



