#!/bin/bash

set -e  # Exit on any Error
#set -x

echo "#######################################"
echo "#####  Running Pre Commit checks ######"
echo "#######################################"


SCRIPTDIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
CYPRESSROOT="${SCRIPTDIR}/.."

cd ${SCRIPTDIR}/../..

# Need to run git commands in top level dir
# Find staged typescript files
FILES=$(git commit --dry-run --untracked-files=no --porcelain | grep '^[MA].*\.ts' | cut -b 4- | sed -e 's:^:../:' )

echo
echo "#######################################"
echo "#####   Staged Typescript Files   #####"
for f in ${FILES}; do
  echo ${f}
done
echo "#######################################"

# Need to run npm commands here
cd ${SCRIPTDIR}/..

# echo ${FILES}

# Run tslint
echo
echo "#######################################"
echo "#####   Running tslint            #####"
echo ${FILES} | xargs npm run tslint
echo "#######################################"

# Run prettier
echo
echo "#######################################"
echo "#####   Running prettier          #####"
echo ${FILES} | xargs npx prettier --config ./prettier.config.js --list-different
echo "#######################################"


