export function email_settings(): { [key: string]: string } {
  return {
    email_host_user: 'viz-qe@mailhog.com',
    // mailhog does not require a password, but the VIZ UI does, so the value below is "aaaaaa" or similar
    email_host_password: `{"secret": "gAAAAABij9c0T5xxkctkVcbDTzGclAY82umsSUZp3rowMtRL1jr1yaLqJCcR40xwqpsIwQuJBK6Qeoncpz2eG-C5T_tCNM7Jew==", "algo": "pbkdf2_sha256", "iterations": "100000", "salt": "eJQPh0eq7XV7w/np"}`,
    email_host: 'mailhog',
    email_port: '1025',
    email_use_tls: 'false',
    // the setting above is for 6.4, the one below is for 7.0
    // email_protocol: 'None', // before VIZ 7.0.4
    email_protocol: 'NEITHER', // since  VIZ 7.0.4.
    // Todo: instead of writing to the DB we should apply the settings using some other method because
    // the DB migrations are not applied this way.
    // email_enabled: 'true', // let the tests change this setting through the UI
  };
}

// not needed since duckdb 0.10.0
// for the workaround code see VIZ-1867
// const duckdb_workaround

const kerberos_setup = `
KERBEROS_PRINCIPAL='systest@CC-OS.CLOUDERA.COM'
KERBEROS_KEYTAB='/data/systest.keytab'

# CDP overrides KRB5_CONFIG with its own, here we over-override:
import os; os.environ['KRB5_CONFIG']='/data/viz-team-cdpdc-krb5.conf'

# the tickets expire after 10 hours
KERBEROS_RENEW_SECONDS=9*3600
`;

/*
These are only needed for local testing
INSTALLED_APPS = INSTALLED_APPS + ('trustedauth',)
AUTHENTICATION_BACKENDS = (
      'django.contrib.auth.backends.ModelBackend',
      'trustedauth.backends.TrustedAuthBackend'
)
*/

const trusted_auth_setup = `
TRUSTED_AUTH = {
    'trusted_users': ['tadmin'],
    'timeout': 30,
    'single_use': True,
    'session_expiry': 0,
    'allow_superuser': False,
}
`;

const combined_setup = `
${kerberos_setup}
${trusted_auth_setup}
`;

export function advanced_settings(): string[] {
  return [
    `ADMIN_API_URL_LIST=['*']`,
    'INCLUDE_CANTEEN=True',
    'ENABLE_API_KEYS=True',
    'ENABLE_DATACONN_DUCKDB=True',
    'ADMINAPI_REQUIRE_APIKEY=True',
    ...combined_setup
      .split('\n')
  ];
}
