#!/usr/bin/env python -tt

import os
import sys
import subprocess

FULLSMOKE = "./cypress/tests/visuals/smoke/*.ts"
SMOKE = "./cypress/tests/visuals/smoke/arc_visual_pie.ts"

def displayEnv():
  print("URL=%s" % os.getenv("URL"))
  print("CONTAINER=%s" % os.getenv("CONTAINER"))
  print("CONTAINERPORT=%s" % os.getenv("CONTAINERPORT"))
  print("TESTSPEC=%s" % os.getenv("TESTSPEC"))

def run(cmdl):
  displayEnv()
  print("+ %s" % ' '.join(cmdl))
  subprocess.run(cmdl, check=True)

def main():
  port = os.getenv("CONTAINERPORT")
  if not port:
    port = 38888
    os.environ["CONTAINERPORT"] = "38888"

  runtarget = sys.argv[1]
  if runtarget not in ['local', 'cdwvizapps']:
    raise Exception('Invalid runtarget %s' % runtarget)

  yamlfile = "docker-compose-%s.yml" % runtarget

  testName = sys.argv[2]
  if testName not in ['smoke', 'fullsmoke']:
    raise Exception('Invalid runtarget %s' % runtarget)

  if testName == 'smoke':
    testSpec = SMOKE
  elif testName == 'fullsmoke':
    testSpec = FULLSMOKE

  os.environ["TESTSPEC"] = testSpec

  cmd = "docker-compose -f %s up --remove-orphans --abort-on-container-exit --exit-code-from viztest viztest" % yamlfile
  cmdl = cmd.split()
  run(cmdl)

if __name__ == "__main__":
  main()

