#!/usr/bin/env python3 -tt

import json

class Template(object):
  def __init__(self, s):
    self.label = s.rstrip().rstrip(">").split()[1]
    self.records = []

  def process(self, j):
    self.records.append(j)

  def finalize(self):
    with open(f"locust_template_{self.label}.txt", "w") as f:
      for record in self.records:
        f.write(record)

def main():
  import sys

  template = None

  for line in sys.stdin:
    if line.startswith("<START"):
      template = Template(line)
      continue

    if line.startswith("<STOP"):
      template.finalize()
      template = None
      continue

    if template:
      template.process(line)

if __name__ == "__main__":
  main()

